program define _fracwgt
/*
	Deal with weights.

	in: exp, touse, weight
	out: S_1=mnlnwt, S_2=wgt
*/
	local exp "`1'"
	local touse "`2'"
	local weight "`3'"
	local mnlnwt 0 /* mean log normalized weights */
	if "`exp'" != "" { 
		tempvar s
		gen `s' `exp'
		replace `touse'=0 if `s'<=0|`s'==.
		replace `s'=. if !`touse'
		if "`weight'"=="fweight" { 
			capture assert `s'==int(`s') if `touse'
			if _rc { noi error 401 } 
		}
		sum `s' 
		noi di "(sum of wgt is " _result(1)*_result(3) ")"
		replace `s'=log(`s'/_result(3))
		sum `s'
		local mnlnwt=_result(3)
		local wgt "[`weight'`exp']"
	}
	global S_1 `mnlnwt'
	global S_2 `wgt'
end
