*! version 1.0.1  12mar1997
program define bs
	version 5.0
	local cmd   "`1'"
	local stats "`2'"
	macro shift 2
	local opts "`*'"

	if "`cmd'"=="" { error 198 }
	if "`stats'"=="" {
		di in red "list of statistics not found"
		exit 111
	}
	parse "`stats'", parse(" ")

/* Display command and list of statistics. */

	di in gr _n "command:     `cmd'"

	if "`2'"=="" { di in gr "statistic:   `stats'" }
	else	       di in gr "statistics:  `stats'"

/* Run command to see if it runs without error. */

	capture `cmd'
	if _rc {
		di in red "error when command executed on original dataset"
		di in blu "note: must enclose command in quotes and " /*
		*/ "list of statistics in quotes"
		error _rc
	}

/* Check list of statistics. */

	tempname x
	local stats /* erase macro */
	local i 1
	while "``i''"!="" {
		local vl     "`vl' bs`i'"
		local labs   "`labs' ``i''"
		local stats  "`stats' (``i'')"

		Dollar ``i''

		capture scalar `x' = $S_bs_so
		if _rc {
			global S_bs_so /* erase macro */
			di in red "error in statistic: ``i''"
			di in blu "note: must enclose command in quotes " /*
			*/ "and list of statistics in quotes"
			exit 198
		}
		local i = `i' + 1
	}
	global S_bs_so /* erase macro */

/* Stuff in `opts', if anything, should be options.  Check this. */

	local options "*"
	capture parse "`opts'"
	if _rc {
		di in red "must enclose command in quotes and " /*
		*/ "list of statistics in quotes"
		exit _rc
	}

	global S_bs_vl  "`vl'"
	global S_bs_lab "`labs'"
	global S_bs_cmd "`cmd'"
	global S_bs_st  "`stats'"

	bstrap _BS `opts' /* program _BS is in bstrap.ado file */

	global S_bs_vl  /* erase macros */
	global S_bs_lab
	global S_bs_cmd
	global S_bs_st
end

program define Dollar /* put $ in front of any S_ */
	version 5.0
	local mac "`1'"

	local i = index("`mac'","S_")
	local n = length("`mac'")
	local j 1
	while `i' != 0 & `j' <= `n' {
		local front = substr("`mac'",1,`i'-1)
		local back  = substr("`mac'",`i',.)
		local mac "`front'$`back'"
		local i = index("`mac'","S_")
		local j = `j' + 1 /* prevents infinite loop if error */
	}
	global S_bs_so "`mac'"
end
