*! version 3.3.3 27mar1997
program define cs
	version 3.1
	local varlist "req ex min(2) max(2)"
	local if "opt"
	local in "opt"
	local weight "fweight"
	#delimit ;
	local options "BY(string) noHet noCrude Exact EStandard Fast 
		IStandard Level(integer $S_level) OR Pool RD Standard(string) 
		TB Woolf" ;
	#delimit cr
	parse "`*'"
	parse "`varlist'", parse(" ")
	local cas `1'
	local ex `2'
	local stdflg=("`standar'"!="")+("`estanda'"!="")+("`istanda'"!="")
	if `stdflg'>1 { error 198 }
	tempvar use WGT one first decoded
	quietly { 
		gen byte `use'=1 `if' `in'
		replace `use'=0 if `cas'==. | `ex'==. | `use'==.
		if "`weight'"!="" { 
			gen double `WGT' `exp' if `use'
			replace `use'=0 if `WGT'==.
			capture assert `WGT'>=0 & `WGT'==int(`WGT') if `use'
			if _rc { 
				noisily di in red /*
				*/ "`WGT' negative or noninteger"
				exit 499
			}
			local w "[fweight=`WGT']"
		}
	}
	if "`by'"!="" { 
		parse "`by'", parse(" ")
		if "`2'"!="" { error 198 } 
		confirm var `by'
		capture replace `use'=0 if `by'==.	/* fail on str ok */
		quietly { 
			sort `use' `by'
			if "`standar'"!="" {
				noi confirm var `standar'
				capture assert `standar'>=0 if `use'
				if _rc {
					noi di in red /*
					*/ "`standar' has negative values"
					exit 498
				}
				capture by `use' `by': assert /*
				*/ `standar'==`standar'[_n-1] if _n>1 & `use'
				if _rc {
					noi di in red /*
				*/ "`standar' not constant within `by'"
					exit 198
				}
			}
			by `use' `by': gen byte `first'=1 if _n==1 & `use'
			sort `first' `by'
			if "`crude'" == "" {
				if "`level'" != "" { 
					local ml "level(`level')" }
				else 	local ml ""

				local myopt ", `or' `tb' `woolf' `exact' `ml'"
				cs `cas' `ex' `if' `in' `w' `myopt'
				if "`or'"!="" {
					local CRUDE  $S_9 
					local C0     $S_10
					local C1     $S_11
				}
				else {
				  if "`rd'" != "" {
					local CRUDE  $S_3 
					local C0     $S_4
					local C1     $S_5
				  }
				  else {
					local CRUDE  $S_6 
					local C0     $S_7
					local C1     $S_8
				  }
				}
				
				local CTYPE  "(Cornfield)"
				if "`tb'" != ""    { local CTYPE  "(tb)" }
				if "`woolf'" != "" { local CTYPE  "(Woolf)" }
			}
		}
	}
	else {
		if `stdflg' | "`rd'" != ""{ 
			error 198 
		}
	}
	quietly gen byte `one'=1
	_crcvarl `ex'
	local col "col($S_1)"

	if "`by'"=="" { 
		quietly { 
			safesum `one' `w' if `cas' & `ex' & `use'
			local a=$S_1
			safesum `one' `w' if `cas' & `ex'==0 & `use'
			local b=$S_1
			safesum `one' `w' if `cas'==0 & `ex' & `use'
			local c=$S_1
			safesum `one' `w' if `cas'==0 & `ex'==0 & `use'
			local d=$S_1
		}
		csi `a' `b' `c' `d', level(`level') /*
			*/ `col' `or' `woolf' `tb' `exact'
		exit
	}

	if `level'<10 | `level'>99 { local level 95 } 

	local lby : value label `by'
	if "`lby'"!="" { 
		quietly decode `by', gen(`decoded')
		local lby "`decoded'"
	}
	else	local lby `by'

	local lbl : var label `by'
	if "`lbl'"=="" { local lbl "`by'" }
	else local lbl = substr("`lbl'",1,16)
	local skip=16-length("`lbl'")

	if "`or'"!="" { 
		if `stdflg'!=0 { 
			error 198
		}
		local type "OR" 
	}
	else if "`rd'"!="" { 
		if `stdflg'==0 { 
			error 198 
		}
		local type "RD" 
	}
	else local type "RR"

	if `stdflg'== 0 { local hdr2 "M-H" }
	else local hdr2 "   "

	di _n in gr _skip(`skip') "`lbl' |" _col(26) "`type'" /*
	*/ _col(34) "[`level'% Conf. Interval]    `hdr2' Weight" _n /*
	*/ _dup(17) "-" "+" _dup(49) "-"

	#delimit ;
	local i 1; local df 0; 	local iz=invnorm(1-(1-`level'/100)/2); 
	local Swgt 0;  local Sor 0;  local SPR 0; local SR 0;
	local SPSQR 0; local SS 0;   local SQS 0; local SXnum 0;
	local SXden 0; local S1 0;   local S2 0;  local or0 .;
	local or1 .;   local POOL .; local P0 .;  local P1 .;    local Sa 0;
	local Sb 0;    local Sc 0;   local Sd 0;  local Sn0 0;   local Sn1 0;
	local pnum 0;  local pden 0; /* local nf ; */

	tempvar irr virr Sf;

	qui gen `Sf'=. ;  qui gen `irr'=. ;	qui gen `virr'=. ;
	#delimit cr
	
	while 1 { 			
		if `first'[`i']!=1 {     /* End of `by' loop */

	#delimit ;
	mac def S_1 . ; mac def S_2 . ; mac def S_3 . ; mac def S_4 . ;
	mac def S_5 . ; mac def S_6 . ; mac def S_7 . ; mac def S_8 . ;
	mac def S_9 . ; mac def S_10 .; mac def S_11 .; mac def S_12  ;
	mac def S_13  ; mac def S_14  ;
	#delimit cr

			if `stdflg'==0 {
				local or=`Sor'/`Swgt'
				if "`type'"=="OR" { 
					local se=sqrt(`SPR'/(2*(`SR'^2))+/*
					*/ `SPSQR'/(2*`SR'*`SS')+/*
					*/ `SQS'/(2*(`SS'^2)))
					local x2=(`SXnum'^2)/`SXden'
					mac def S_1 `x2'
					if "`tb'"=="" {
					   local or0=exp(ln(`or')-`iz'*`se')
					   local or1=exp(ln(`or')+`iz'*`se')
					}
					else {
					   local x=`SXnum'/sqrt(`SXden')
					   local or0=`or'^(1-`iz'/`x')
					   local or1=`or'^(1+`iz'/`x')
					   if `or0'>`or1' { 
						local h `or1'
						local or1 `or2'
						local or2 `h'
					   }
					   local note "tb"
					}
				}
				else {	/* RR */
					local se=sqrt(`S1'/(`S2'*`Swgt'))
					local or0=exp(ln(`or')-`iz'*`se')
					local or1=exp(ln(`or')+`iz'*`se')
				}
				local hdr2 "   M-H combined"
				local paren "M-H"
			}
			else {
				if "`estanda'"!="" {
					local hdr2 "E. Standardized"
					local paren "E.S."
				}
				else if "`istanda'"!="" {
					local hdr2 "I. Standardized"
					local paren "I.S."
				}
				else 	{
					local hdr2 "   Standardized"
					local paren "STD."
				}
				if "`type'"=="RR" {
					local or=`SXnum'/`SXden'
					local se=sqrt(`SPR'/`SXnum'^2+/*
						*/ `SR'/`SXden'^2)
					local or0=exp(ln(`or')-`iz'*`se')
					local or1=exp(ln(`or')+`iz'*`se')
				}
				else {
					local or=`Sor'/`Swgt'
					local se=sqrt(`SXnum'/`Swgt'^2)
					local or0=`or'-`iz'*`se'
					local or1=`or'+`iz'*`se'
				}
			}
			if "`type'"=="RR" {
				mac def S_6 `or'
				mac def S_7 `or0'
				mac def S_8 `or1'
			}
			else if "`type'"=="OR" {
				mac def S_9 `or'
				mac def S_10 `or0'
				mac def S_11 `or1'
			}
			else {	/* RD */
				mac def S_3 `or'
				mac def S_4 `or0'
				mac def S_5 `or1'
			}

			if "`note'"=="" { local  jopt "" }
			else local jopt "mote(`note')"

* Call dispcs

			dispcs "`Sf'" "`irr'" "`virr'" /*
			*/ "`CRUDE'" "`C0'" "`C1'"   /*
			*/ "`pnum'" "`pden'" "`iz'" "`df'" /*
			*/ "`or'" "`or0'" "`or1'" "`stdflg'" "`x2'" /*
		begin options 
			*/	`het' `pool' `jopt' type(`type') 	   /*
			*/	hdr2("`hdr2'") paren("`paren'") `crude'

                        *if "`nf'"=="error" & `stdflg'==0{
                          *di
                          *di in bl "Note: Stratum specific estimates appear"/*
                          **/    " both sides of the null value. "
                          *di in bl "      This problem may require " /*
			  * */ "standardization."
                        *}
			exit
		}
		quietly { 
			safesum `one' `w' /*
			*/ if `cas' & `ex' & `use' & `by'==`by'[`i']
			local a=$S_1
			safesum `one' `w' /* 
			*/ if `cas' & `ex'==0 & `use' & `by'==`by'[`i']
			local b=$S_1
			safesum `one' `w' /*
			*/ if `cas'==0 & `ex' & `use' & `by'==`by'[`i']
			local c=$S_1
			safesum `one' `w' /*
			*/ if `cas'==0 & `ex'==0 & `use' & `by'==`by'[`i']
			local d=$S_1
		}
		* csi `a' `b' `c' `d', level(`level') `col' `woolf'
		local m1=`a'+`b'
		local m0=`c'+`d'
		local n1=`a'+`c'
		local n0=`b'+`d'
		local t=`n1'+`n0'

		if `stdflg'==0 {
			if "`type'"=="OR" { 
				local wgt=(`b'*`c')/`t'
				local or=(`a'*`d')/(`b'*`c')

				local P=(`a'+`d')/`t'
				local Q=(`b'+`c')/`t'
				local R=(`a'*`d')/`t'
				local S=(`b'*`c')/`t'
				local SPR=`SPR'+`P'*`R'
				local SR=`SR'+`R'
				local SPSQR=`SPSQR'+`P'*`S'+`Q'*`R' /*sic*/
				local SS=`SS'+`S'
				local SQS=`SQS'+`Q'*`S'

				local SXnum=`SXnum'+`a'-(`n1'*`m1')/`t'
				local SXden=`SXden'+/*
				*/ (`n1'*`n0'*`m1'*`m0')/(`t'^2*(`t'-1))

				mac def S_4
				if "`fast'"=="" { 
					_crcor `a' `b' `c' `d' `level' /*
						*/ `woolf' `tb'
/*
					if "`nf'"=="" {
						if $S_1 < 1.0 { 
							local nf "below" 
						}
						else          { 
							local nf "above" 
						}
					}
					else {
						if $S_1<1.0 & "`nf'"=="above"{
							local nf="error"
						}
						else if $S_1 > 1.0 & /*
						*/ "`nf'"=="below" {
							local nf="error"
						}
					}
*/

					local or0 $S_2
					local or1 $S_3
				}
if `t' != 0 {
				local Sor=`Sor'+(`a'*`d')/`t'
}
			}
			else { 
				local wgt=(`b'*`n1')/`t'
				_crcrr `a' `b' `c' `d' `level' `tb'
/*
                                if "`nf'"=="" {
                                        if $S_1 < 1.0 { local nf "below" }
                                        else          { local nf "above" }
                                }
                                else {
                                        if $S_1 < 1.0 & "`nf'"=="above" {
                                                local nf="error"
                                        }
                                        else if $S_1>1.0 & "`nf'"=="below" {
                                                local nf="error"
                                        }
                                }
*/
				local or $S_1
				local or0 $S_2
				local or1 $S_3
				local S1=`S1'+ /*
				*/ (`m1'*`n1'*`n0'-`a'*`b'*`t')/(`t'^2)
				local S2=`S2'+(`a'*`n0')/`t'
/*
if `or' != . {
				local Sor=`Sor'+`wgt'*`or'
}
*/				local Sor = `Sor' + (`a'*`n0')/`t'
			}
			local Swgt=`Swgt'+`wgt'
		}
		else {	/* standardize */
			if "`estanda'"!="" { local wgt `n0' }
			else if "`istanda'"!="" { local wgt `n1' }
			else local wgt=`standar'[`i']
			local Swgt = `Swgt'+`wgt'
			local R1=`a'/`n1'
			local R0=`b'/`n0'
			local vR1=(`a'*`c')/`n1'^3
			local vR0=(`b'*`d')/`n0'^3
			if "`type'"=="RR" { 
				_crcrr `a' `b' `c' `d' `level' `tb'
/*
                                if "`nf'"=="" {
                                        if $S_1 < 1.0 { local nf "below" }
                                        else          { local nf "above" }
                                }
                                else {
                                        if $S_1 < 1.0 & "`nf'"=="above" {
                                                local nf="error"
                                        }
                                        else if $S_1 > 1.0 & "`nf'"=="below" {
                                                local nf="error"
                                        }
                                }
*/
				local or $S_1
				local or0 $S_2
				local or1 $S_3
				local SXnum=`SXnum'+`wgt'*`R1'
				local SXden=`SXden'+`wgt'*`R0'
				local SPR=`SPR'+`wgt'^2*`vR1'
				local SR=`SR'+`wgt'^2*`vR0'
			}
			else {	/* RD */
				_crcrd `a' `b' `c' `d' `level' `tb'
/*
                                if "`nf'"=="" {
                                        if $S_1 < 0.0 { local nf "below" }
                                        else          { local nf "above" }
                                }
                                else {
                                        if $S_1 < 0.0 & "`nf'"=="above" {
                                                local nf="error"
                                        }
                                        else if $S_1 > 0.0 & "`nf'"=="below" {
                                                local nf="error"
                                        }
                                }
*/
				local or $S_1
				local or0 $S_2
				local or1 $S_3
				local Sor=`Sor'+`wgt'*`or'
				local SXnum=`SXnum'+`wgt'^2*(`vR0'+`vR1')
			}
		}

		local Sa = `Sa'+`a'
		local Sb = `Sb'+`b'
		local Sc = `Sc'+`c'
		local Sd = `Sd'+`d'
		local Sn0 = `Sn0'+`n0'
		local Sn1 = `Sn1'+`n1'

		qui replace `irr'=`or' in `i'

		if "`type'"=="OR" { 
			qui replace `irr' = (`a'*`d')/(`b'*`c') in `i'
			qui replace `virr'= 1/`a'+1/`b'+1/`c'+1/`d' in `i'
		}
		if "`type'"=="RR" { 
			qui replace `irr' = (`a'/`n1')/(`b'/`n0') in `i'
			qui replace `virr'=`c'/(`a'*`n1')+`d'/(`b'*`n0') in `i'
		}
		if "`type'"=="RD" {
			qui replace `irr' = (`a'/`n1')-(`b'/`n0') in `i'
			qui replace `virr'= (`a'*`c')/(`n1'^3) + /*
				*/	(`b'*`d')/(`n0'^3) in `i'
		}
		

if `irr'[`i']/`virr'[`i'] != . {
		if "`type'"=="RD" { 
				local pnum = `pnum' + `irr'[`i']/`virr'[`i'] 
		}
		else local pnum = `pnum'+log(`irr'[`i'])/`virr'[`i']
		local pden = `pden' + 1/`virr'[`i']
}


		local lbl=`lby'[`i']
		local lbl=substr("`lbl'",1,16)
		local skip=16-length("`lbl'")
		di in gr _skip(`skip') "`lbl' |  " in ye /*
			*/ %9.0g `or' "    " %9.0g `or0' "  " %9.0g `or1' /*
			*/ "     " %9.0g `wgt' in gr " $S_4"
		local i=`i'+1
		local df=`df'+1

	}
	/*NOTREACHED*/
end


prog define dispcs
	version 3.1
	local Sf "`1'"		/* variable names */
	local irr "`2'"
	local virr "`3'"
	mac shift 3
	local CRUDE `1'
	local C0 `2'
	local C1 `3'
	local pnum `4'
	local pden `5'
	local iz `6'
	local df `7'
	local or `8'
	local or0 `9'
	local or1 `10' 	
	local stdflg `11'
	local x2 `12'
	mac shift 12

	#delimit ;
	local options "TYPE(string) MOTE(string) HDR2(string) 
		ARGS(string) noHET POOL PAREN(string) noCRUDE" ;
	#delimit cr
	parse ", `*'"

	local hdr2 = trim("`hdr2'")

	if "`hdr2'" == "M-H combined" | "`hdr2'"=="Standardized" {
		local hdr2 "   `hdr2'"
	}

	di in gr _dup(17) "-" "+" _dup(49) "-" 
	if "`crude'" == "" {
		di in gr "           Crude |  " in ye /*
		*/	%9.0g `CRUDE' "    " %9.0g `C0' "  "  /*
		*/	%9.0g `C1'    in gr _col(69) "`CTYPE'"
	}

	if "`pool'" != "" {
		if "`type'"=="RD" { 
			local POOL = `pnum'/`pden'
			local sd = sqrt(1/`pden')
			local P0 = `POOL'-`iz'*`sd'
			local P1 = `POOL'+`iz'*`sd'

			local dfm1=`df'-1
			quietly replace `Sf'= sum( /*
				*/ (`irr'-`POOL')^2/`virr') in 1/`df'
			local pchi=`Sf'[`dfm1'+1]
			local pval=chiprob(`dfm1',`pchi')
		}
		else { 
			local POOL = exp(`pnum'/`pden') 
			local sd = sqrt(1/`pden')
			local P0 = exp(log(`POOL')-`iz'*`sd')
			local P1 = exp(log(`POOL')+`iz'*`sd')

			local dfm1=`df'-1
			quietly replace `Sf'= sum( /*
				*/ (log(`irr')-log(`POOL'))^2/`virr') in 1/`df'
			local pchi=`Sf'[`dfm1'+1]
			local pval=chiprob(`dfm1',`pchi')
		}
		di in gr " Pooled (direct) |  " in ye /*
		*/	%9.0g `POOL' "    " %9.0g `P0' "  "  /*
		*/	%9.0g `P1'    

	}

	if "`mote'"=="" {
		di in gr " `hdr2' |  " in ye /* 
		*/ %9.0g `or' "    " %9.0g `or0' "  " %9.0g `or1' 
	}
	else {
		di in gr " `hdr2' |  " in ye /* 
		*/ %9.0g `or' "    " %9.0g `or0' "  " %9.0g `or1' /*
		*/ in gr _col(69) "(`mote')"
	}

	if "`het'" == "" {
	  if "`pool'" != "" | "`paren'"=="M-H" {
	    di in gr _dup(17) "-" "+" _dup(49) "-"
	  }
	  if "`pool'" != "" {
	    di in gr /*
		    */ "Test for heterogeneity " /*
		    */ "(direct)  chi2(" in ye "`dfm1'" in gr /*
		    */ ") = " in ye %9.3f `pchi' in gr /*
		    */ "  Pr>chi2 = " in ye %6.4f `pval'
	    global S_26 = `dfm1'
	    global S_27 = `pchi'
	  }

	  if "`paren'"=="M-H" {
	    if "`type'"=="RD" {
	      local dfm1=`df'-1
	      quietly replace `Sf'= sum( /*
	        */ (`irr'-`or')^2/`virr') /*
	        */ in 1/`df'
quietly summ `irr' in 1/`df'
local cdf = _result(1) - 1
	      local mchi=`Sf'[`dfm1'+1]
	      *local mval=chiprob(`dfm1',`mchi')
local mval=chiprob(`cdf',`mchi')
	    }
	    else {
	      local dfm1=`df'-1
	      quietly replace `Sf'= sum( /*
	        */ (log(`irr')-log(`or'))^2/`virr') /*
	        */ in 1/`df'
quietly summ `irr' in 1/`df'
local cdf = _result(1) - 1
	      local mchi=`Sf'[`dfm1'+1]
	      *local mval=chiprob(`dfm1',`mchi')
local mval=chiprob(`cdf',`mchi')
	    }

	if `cdf' > 0 {
	    di in gr /*
		    */ "Test for heterogeneity " /*
		    */ "(`paren')"   _col(34) "chi2(" in ye "`cdf'" in gr /*
		    */ ") = " in ye %9.3f `mchi' in gr /*
		    */ "  Pr>chi2 = " in ye %6.4f `mval'
	    global S_26 = `cdf'
	    global S_25 = `mchi'
	}
	  }
	}

	if "`type'"=="OR" & `stdflg'==0 { 
		di in gr _n _col(20) /*
			*/ "Test that combined OR = 1:" _n _col(33) /*
			*/ "Mantel-Haenszel chi2(1) =" /*
			*/ in ye %10.2f `x2' _n in gr /*
			*/ _col(49) "Pr>chi2 =" in ye /*
			*/ %10.4f chiprob(1,`x2')
	}
end
