*! version 1.5.1 PR 09Jan98.
program define fracpoly
version 5.0
if "`1'" == "" | substr("`1'",1,1)=="," {
	if "$S_E_cmd"=="" 		{ error 301 }
	if "$S_E_fp"!="fracpoly"	{ error 301 }
	di in blue "->$S_E_cmd"
	$S_E_cmd
	fraccomp `*'
	exit
}
loc cmd `1'
mac shift
_fracchk `cmd' 
if $S_1 {
	di in red "invalid or unrecognised command, `cmd'"
	exit 198
}
/*
	dist=0 (normal), 1 (binomial), 2 (poisson), 3 (cox), 4 (glm),
	5 (xtgee), 6(ereg/weibull).
*/
loc dist $S_2
loc glm $S_3
loc qreg $S_4
loc xtgee $S_5
loc normal $S_6

loc star "`1' `2'"
mac shift 2
/*
	Look for fixpowers
*/
loc done 0
while !`done' {
	local s=index("`1'",",")
	local doshift=`s'==0	/* no comma found */
	if `doshift' {
		local pow `1'
	}
	else {
		local pow=substr("`1'",1,`s'-1)
	}
	cap confirm num `pow'
	if _rc==0 {	/* pow confirmed as a number */
		if "`fixpowe'"=="" { loc fixpowe `pow' }
		else loc fixpowe "`fixpowe' `pow'"
		local 1=substr("`1'",`s',.)
		if `doshift' { mac shift }
	}
	else loc done 1
}
local star "`star' `*'"

loc varlist "req ex min(2)"
loc if "opt"
loc in "opt"
loc weight "aweight fweight pweight iweight"
loc search="`fixpowe'"==""
if `search' {
	loc srchopt "ADDpowers(str) DEVthr(real 1e30) POwers(str) DEGree(int 2) LOg COMpare"
}
loc options "DEAD(str) CATzero EXPx(str) ORIgin(str) ZERo noCONStant noSCAling `srchopt' *"
loc small 1e-6
parse "`star'"
_fraccox "`dead'" `dist'
loc cz="`catzero'"!=""
if `cz' { loc zero zero }
if `search' {
	if `degree'<1 | `degree'>9 {
		di in red "invalid degree()"
		exit 198
	}
	loc df=2*`degree'
	loc odddf=(2*int(`df'/2)<`df')
}
else loc df 1
loc lin=("`fixpowe'"=="1") & ("zero'"=="") & ("catzero'"=="")
if "`constan'"=="noconstant" {
	if "`cmd'"=="fit" | "`cmd'"=="cox" {
		di in red "noconstant invalid with `cmd'"
		exit 198
	}
	loc options "`options' nocons"
}
/*
	 Read powers to be searched into a variable, `p'
*/
if `search' {
	if "`powers'"=="" { loc powers "-2,-1,-.5,0,.5,1,2,3" }
	loc pwrs "`powers' `addpowe'"
	tempvar p
	qui gen `p'=.
	_fracpp `p' "`pwrs'" 1 1
	loc np $S_1
	if `np'<1 {
		di in red "no powers given"
		exit 2002
	}
	loc pwrs "$S_3"
}
gl S_E_cmd
parse "`varlist'", parse(" ")
loc y `1'
mac shift
loc rhs `1'
mac shift
loc base `*'
tempvar touse x lnx

quietly {
	mark `touse' [`weight' `exp'] `if' `in'
	markout `touse' `rhs' `y' `base' `dead'
	if "`dead'"!="" { local options "`options' dead(`dead')" }
	gen `x'=`rhs' if `touse'
	lab var `touse' "fracpoly sample"
/*
	Deal with weights.
*/
	_fracwgt "`exp'" `touse' "`weight'"
	loc mnlnwt $S_1 /* mean log normalized weights */
	loc wgt $S_2
	gen `lnx'=.
	_fracxo `x' `lnx' `lin' "`expx'" "`origin'" "`zero'" "`scaling'"
	loc nobs $S_1
	if $S_3==0 {
		loc zeta $S_2
		loc shift 0
	}
	else loc shift $S_2
	loc kx "$S_4"
	loc scalfac $S_5
	if `cz' {
		tempvar catz
		gen byte `catz'=`x'<=0
	}
}
/*
	Store coefficients for linear fit on untransformed x
*/
qui `cmd' `y' `rhs' `base' `wgt' if `touse', `options'
cap local b0=_b[_cons]
if _rc { local b0 0 }
cap local b1=_b[`rhs']
if _rc {
	di in red "could not fit linear model for `rhs'"
	exit 2001
}
/*
	Determine residual and model df.
*/
qui reg `y' `base' `wgt' if `touse'
loc rdf=_result(5)+("`constan'"=="noconstant")
/*
	Calc deviance=-2(log likelihood) for regression on covars only,
	allowing for possible weights.

	Note that for logit/clogit/logistic with nocons, must regress on zero,
	otherwise get r(102) error.
*/
if `dist'==1 & "`constan'"=="noconstant" {
	tempvar z0
	qui gen `z0'=0
}
qui `cmd' `y' `z0' `base' `wgt' if `touse', `options'
if `xtgee' & "`base'"=="" { global S_E_chi2 0 }
loc glmwarn 0
if `glm' {
 loc scale 1
 if abs($S_E_dc/$S_E_del-1)>`small' & abs($S_E_dd/$S_E_del-1)>`small' {
	loc scale $S_E_del
 }
 else loc glmwarn 1
}
_fracdv `normal' "`wgt'" `nobs' `mnlnwt' `dist' `glm' `xtgee' `qreg' "`scale'"
loc dev0 $S_1
if `normal' { loc rsd0=_result(9) }
if `search' {
	loc m `degree'
	if "`log'"!="" {
		di _n in gr "Model #      Deviance " _cont
		if `normal' { di in gr "  Res S.D. " _cont }
		loc i 1
		while `i'<=`m' {
			di in gr " Power " `i' _cont
			loc i=`i'+1
		}
		di _n
	}
/*
	Go!
*/
	loc i 1
	while `i'<=`np' {
		loc pi=`p'[`i']
		tempvar x`i'
		qui gen `x`i''=cond(`pi'==0, `lnx', /*
		 */ cond(`pi'==1, `x', cond(`x'==0,0,`x'^`pi')))
		loc i=`i'+1
	}
	loc i 0
	while `i'<`m' {
		loc j`i' 0
		loc i=`i'+1
		tempvar xp`i'
		qui gen `xp`i''=.
		loc j=`i'+`i'-1
		loc dev`j' `dev0' /* min deviance for df=j */
		loc j=`j'+1
		loc dev`j' `dev0'
	}
	loc j`m' 1
	loc i `m'
	loc kount 0  /* no. of models processed */
	loc kountd 0 /* no. of models with deviance<`devthr' */
	loc deg `j`m''
	loc done 0
	while !`done' {
		if `i'<`m' {
			loc ji `j`i''
			qui replace `xp`i''=`x`ji''
			loc l `i'
			while `l'<`m' {
				loc l=`l'+1
				loc j`l' `ji'
				loc l1=`l'-1
				qui replace `xp`l''=`xp`l1''*`lnx'
			}
			if "`log'"=="" { di "." _cont }
		}
		else qui replace `xp`m''=`x`j`m'''
/*
	Test for any power being 1 (i.e. odd-df model)
*/
		loc one 0
		loc l 0
		while `l'<`m' {
			loc l=`l'+1
			if `p'[`j`l'']==1 { loc one 1 }
		}
		if !`odddf' | (`deg'<`m') | `one' {
			loc dfi=2*`deg'-`one'
			loc i 1
			loc xlist
			while `i'<=`m' {
				if `j`i''>0 { loc xlist "`xlist' `xp`i''" }
				loc i=`i'+1
			}
			loc kount=`kount'+1
			qui `cmd' `y' `xlist' `catz' `base' `wgt' if `touse', /*
			 */ `options'
			_fracdv `normal' "`wgt'" `nobs' `mnlnwt' `dist' /*
			 */ `glm' `xtgee' `qreg' "`scale'"
			loc dev $S_1
			if `normal' { loc rsd=_result(9) }
			if `dev'<`dev`dfi'' {
				loc dev`dfi' `dev'
				if `normal' { loc rsd`dfi' `rsd' }
				loc i 1
				loc pm`dfi'
				while `i'<=`m' {
					if `j`i''>0 {
						loc pm=`p'[`j`i'']
						loc pm`dfi' "`pm`dfi'' `pm'"
					}
					loc i=`i'+1
				}
			}
			if `dev'<`devthr' { loc kountd=`kountd'+1 }
			if "`log'"!="" {
				di in ye %5.0f `kount' /*
				 */ _col(10) %12.3f `dev' _cont
				if `normal' { di "   " %8.0g `rsd' _cont }
				loc i `m'
				while `i'>0 {
					if `j`i''==0 { di _skip(6) ". " _cont }
					else di in ye %8.1f `p'[`j`i''] _cont
					loc i=`i'-1
				}
				di
			}
			if `deg'==1 {
				local fppow=`p'[`j`m'']
				local fpdev`j`m'' "`fppow' `dev'"
			}
		}
/*
	Increment the first possible index (of loop i) among indices of
	loops m, m-1, m-2, ..., 1
*/
		loc i `m'
/*
	Finish after all indices have achieved their upper limits (np).
*/
		while `j`i''==`np' {
			loc i=`i'-1
		}
		if `i'==0 { loc done 1 }
		else {
			if `j`i''==0 { loc deg = `m'-`i'+1 }
			loc j`i'=`j`i''+1
		}
	}
/*
	Update the results for even df to include odd df
*/
	loc i 2
	while `i'<=`df' {
		loc j=`i'-1
		if `dev`j''<`dev`i'' {
			loc dev`i' `dev`j''
			if `normal' { loc rsd`i' `rsd`j'' }
			loc pm`i' "`pm`j''"
		}
		loc i=`i'+2
	}
	if "`log'"=="" { di }
}
/*
	Create FP transformation(s) of xvar for final model
*/
if `search' { loc pwrs `pm`df'' }
else loc pwrs `fixpowe'
if "`expx'"!=""   { local e "expx(`expx')" }
if "`origin'"!="" { local o "origin(`origin')" }
cap drop _sample
rename `touse' _sample
if !`lin' | (`lin' & "`e'`o'"!="") {
	fracgen `rhs' `pwrs' if _sample, replace /*
	 */ `zero' `catzero' `scaling' `e' `o'
	loc xp $S_1
}
else loc xp `rhs'
/*
	Fit final model with permanent _sample filter
*/
`cmd' `y' `xp' `base' `wgt' if _sample, `options'
if !`search' {
/*
	Deviance for fixed-powers model.
	Note that `dev1' is stored in $S_E_dlin, deviance for a
	linear model, even when `fixpowe' is not 1; similarly 
	for `rsd1'.
*/
	_fracdv `normal' "`wgt'" `nobs' `mnlnwt' `dist' `glm' /*
	 */ `xtgee' `qreg' "`scale'"
	loc dev1 $S_1
	if `normal' { loc rsd1=_result(9) }
	loc pm1 `fixpowe'
}
di in gr "Deviance:" in ye %9.3f `dev`df'' in gr ". " _cont
if `search' {
	di in gr "Best powers of " in ye "`rhs'" in gr " among " /*
	 */ in ye `kount' in gr " models fit: " in ye "`pwrs'" _cont
	if `devthr'<1e30 { di _n in gr "Number of models with deviance < " /*
	 */ in ye `devthr' in gr ": " in ye `kountd' _cont }
	di in gr "." _cont
}
di
global S_E_d0 `dev0'
global S_E_s0 `rsd0'
global S_E_dlin `dev1'
if `normal' { global S_E_slin `rsd1' }
loc i 2
loc j 1
while `i'<=`df' {
	global S_E_d`j' `dev`i''
	global S_E_p`j' `pm`i''
	if `normal' { global S_E_s`j' `rsd`i'' }
	loc i=`i'+2
	loc j=`j'+1
}
/*
	New code in v 1.4.7 for consistency with mfracpol
*/
local nbase: word count `base'
local i 0
while `i'<`nbase' {
	local i=`i'+1
	local j=`i'+1
	global S_E_x`j': word `i' of `base'
	global S_E_k`j' 1
}
global S_E_x1 `rhs'
global S_E_k1 `pwrs'
global S_E_nx=`nbase'+1
/*
	End of new code in v 1.4.7 for consistency with mfracpol
*/
if `search' {
	local i `np'
	while `i'>0 {
		global S_E_bt`i' `fpdev`i''
		local i=`i'-1
	}
}
global S_E_b0 `b0'
global S_E_b1 `b1'
global S_E_base `base'
global S_E_df `df'
global S_E_catz `cz'
global S_E_depv `y'
global S_E_dist `dist'
global S_E_fvl `xp' `base'
global S_E_wgt "`weight'"
global S_E_exp "`exp'"
global S_E_fprp no
global S_E_fp fracpoly
global S_E_glmw `glmwarn'
global S_E_nobs `nobs'
global S_E_nxp 0	/* redundant */
global S_E_opts `options'
global S_E_pwrs `pwrs'
global S_E_rdf `rdf'
global S_E_rhs `rhs'
global S_E_srch `search'
global S_E_sfac `scalfac'
global S_E_t1t "Fractional Polynomial"
global S_E_xp `xp'
global S_E_xpx `kx'
global S_E_cmd `cmd'
fraccomp, `compare'
end

program define fraccomp /* report model comparisons */
local options "COMpare"
parse "`*'"
if "`compare'"=="" | $S_E_srch==0 { exit }
local normal=($S_E_dist==0)
local cz $S_E_catz
if `cz' { local catz " + 0" }
local dash "     --"
local ddup=63+15*`normal'
di in gr _n "Fractional Polynomial Model Comparisons:"
di in gr _dup(`ddup') "-"
di in gr "$S_E_rhs" _col(18) "df       Deviance     " _cont
if `normal' { di in gr " Res. SD     " _cont }
di in gr " Gain   P(term) Powers" 
di in gr _dup(`ddup') "-"

di in gr "Not in model" in ye _col(18) " 0" _col(22) %13.3f $S_E_d0 _cont
if `normal' { di in ye _skip(5) %8.0g $S_E_s0 _cont }
di in gr _skip(3) "`dash'`dash'"
local i 1
while `i'<=$S_E_df {
	local m=1+int((`i'-1)/2)
	local idf=`i'+`cz'
	if `i'==1 {
		di in gr "Linear`catz'" _col(18) in ye %2.0f `idf' _col(22) _cont
		local dev $S_E_dlin
		local rsd $S_E_slin
		local d=$S_E_d0-`dev'
		local n1=1+`cz'
		local n2=$S_E_rdf-1-`cz'
		local pwr 1
	}
	else {
		di in gr "m = `m'`catz'" _col(18) in ye %2.0f `idf' _col(22) _cont
		local dev ${S_E_d`m'}
		local rsd ${S_E_s`m'}
		local d=`devlast'-`dev'
		if `m'==1 { local n1 1 }
		else 	    local n1 2
		local n2=$S_E_rdf-2*`m'-`cz'
		local pwr ${S_E_p`m'}
	}
	_fracpv `normal' "$S_E_wgt" $S_E_nobs `d' `n1' `n2'
	local P $S_1
	if `i'==1 { global S_E_Plin `P' }
	else global S_E_P`m' `P'
	di in ye %13.3f `dev' _cont
	if `normal' {
		di in ye _skip(5) %8.0g `rsd' _cont
	}
	di in ye _skip(3) %7.3f $S_E_dlin-`dev' /*
	 */ %9.3f `P' _skip(2) "`pwr'"
	local devlast `dev'
	if `i'==1 { local i=`i'+1 }
	else 	    local i=`i'+2
}
di in gr _dup(`ddup') "-"
if `cz' { di in bl /*
 */ "[Note:`catz' indicates dummy variable for $S_E_rhs=0 included in model]"
}
if $S_E_glmw { di in bl /*
 */ "[warning: GLM deviances are unscaled---ignore P-values]" }
end
