*! version 1.0.0  08apr1998
program define heckpbt
	local options "Level(integer $S_level)"

	if "`1'"!="" & substr("`1'",1,1)!="," {
		tempname touse touse2 b0 b

		/* parsing */
		local varlist "required existing"
		local in "opt"
		local if "opt"
		local options "`options' noConstant noLOg TRace *"
		local weight "fweight aweight"
		parse "`*'"

		/* set sample */
		mark `touse' [`weight'`exp'] `if' `in'
		markout `touse' `varlist' 

		/* split varlist */
		parse "`varlist'", parse(" ")
		local depvar `1'
		mac shift
		local indvars `*'
		
		_rmcoll `indvars'

		/* Set up shared globals w/ likelihood fn */
		global S_const `constan'

		/* Starting values */
		qui regress `depvar' `indvars' [`weight'`exp'] if `touse', `constan'
		mat `b0' = get(_b)
		mat `b0' = 1.65 * `b0'

		if "`weight'" != "fweight" {
			local nobs = _result(1)
		}
		else {
			tempvar wt
			gen double `wt' `exp'
			qui sum `wt'  if `touse', meanonly
			local nobs = round(_result(18),1)
		}

		/* Run ml commands. */

		ml begin
			tempname f V
			eq `depvar' : `depvar' `indvars'
			ml model `b' = `depvar', from(`b0') `constan'
			ml func heckpbtl
			ml method deriv2
			ml sample `touse2' [`weight'`exp']  if `touse',  noauto
			ml depn `depvar'

			if "`log'" == "" {
				ml max `f' `V', `options' `trace'
			}
			else { ml max `f' `V', `options' `trace' }

		ml post heckpbt, obs(`nobs') title(ML Probit model) 

		/* Cleanup */
		mac drop S_const

	}
	else {
		/* parsing re-display */
		if "$S_E_cmd"!="heckpbt" {error 301}
		parse "`*'"
	}

	/* Display */
	if `level'<10 | `level'>99 { local level 95 }
	ml mlout heckpbt, level(`level')

end
