*! version 1.0.4  15jan1998
program define lincom
	version 5.0
	if "$S_E_cmd"=="anova" {
		di in red "lincom does not work after $S_E_cmd"
		exit 301
	}
	parse "`*'", parse(",= ")

	while "`1'"!="" & "`end'"=="" {
		if "`1'"=="=" {
			di in red _quote "=" _quote /*
			*/ " not allowed in expression"
			exit 198
		}
		if "`1'"=="," { local end 1 /* exit loop */ }
		else {
			local formula "`formula'`1'"
			macro shift
		}
	}

	if "`*'"!="" {
		local options "Level(integer $S_level) OR IRr RRr HR EForm"
		parse "`*'"
		local nopt : word count `or' `irr' `rrr' `hr' `eform'
		if `nopt' > 1 {
			di in red "only one display option can be specified"
			exit 198
		}
	}
	else local level = $S_level

	if "$S_E_cmd"=="logistic" { local or "or" }

	if "`or'"!="" {
		local eform "eform(Odds Ratio)"
	}
	else if "`irr'"!="" {
		local eform "eform(IRR)"
	}
	else if "`rrr'"!="" {
		local eform "eform(RRR)"
	}
	else if "`hr'"!="" {
		local eform "eform(Haz. Ratio)"
	}
	else if "`eform'"!="" {
		local eform "eform(exp[b])"
	}

	tempname estname x b V

	qui test `formula' = 0
	scalar `x' = _result(6)
	local  dof = _result(5)
	if `dof'!=. { local dofopt "dof(`dof')" }

	if "$S_E_depv"!="" { local depn "depn($S_E_depv)" }

	matrix `b' = get(_b)
	matrix `V' = get(VCE)

	if "$S_E_cmd"=="mlogit" { Trmlogit `b' `V' }

	nobreak {
		estimates hold `estname'
		capture noisily break {

			_getbv `x' `b' `V' `formula'

		/* Display formula. */

			test `formula' = 0, notest

		/* Save values of b and V for S_# macros. */

			if "`eform'"=="" {
				local est = `b'[1,1]
				local se  = sqrt(`V'[1,1])
			}
			else {
				local est = exp(`b'[1,1])
				local se  = exp(`b'[1,1])*sqrt(`V'[1,1])
			}

		/* Post results. */

			matrix post `b' `V', `dofopt' `depn'
			di
			matrix mlout, `eform' level(`level')
		}
		local rc = _rc
		estimates unhold `estname'
		if `rc' { exit `rc' }
	}
	global S_1 "`est'"
	global S_2 "`se'"
	if `dof'!=. { global S_3 "`dof'" }
	else	      global S_3
end

program define Trmlogit /* transform mlogit beta */
	version 5.0
	local b "`1'"
	local V "`2'"
	tempname row newb s
	mat `newb' = `b'[1,.]
	local nr = rowsof(`b')
	local i 2
	while `i' <= `nr' {
		mat `row' = `b'[`i',.]
		mat `newb' = `newb' , `row'
		local i = `i' + 1
	}
	mat `row' = `V'[1,.] /* steal labels from `V' */
	scalar `s' = 0
	mat `row' = `s'*`row'
	mat `newb' = `newb' + `row' /* put labels from `row' on `newb' */
	mat `b' = `newb'
end
