*! version 1.1.0  28oct1997
program define svylc
	version 5.0
 	if "`*'"=="" { error 198 }
	if substr("$S_E_cmd",1,3)!="svy" {
		error 301
	}
	capture di matrix(S_E_b[1,1])
	if _rc==0 {
		di in red "must run svy command with " _quote "complete" /*
		*/ _quote " option before using this command"
		exit 301
	}

	parse "`*'", parse(",= ")

	if "`1'"=="," {
		local options "SHOW"
		capture parse "`*'"
		if _rc { error 198 }
		if "`show'"!="" {
			di
			matrix mlout
			exit
		}
	}

	while "`1'"!="" & "`end'"=="" {
		if "`1'"=="=" {
			di in red _quote "=" _quote /*
			*/ " not allowed in expression"
			exit 198
		}
		if "`1'"=="," { local end 1 /* exit loop */ }
		else {
			local formula "`formula'`1'"
			macro shift
		}
	}

	if "`*'"!="" {
		if      "$S_E_cmd"=="svylogit" { local or "OR" }
		else if "$S_E_cmd"=="svymlog"  { local rrr "RRr" }
		local options /*
		*/ "Level(int $S_level) DEFF DEFT MEFF MEFT `or' `rrr'"
		parse "`*'"
	}
	else local level $S_level

	capture di matrix(S_E_meft[1,1])
	if _rc { local ismeff 0 }
	else     local ismeff 1

	if "`meff'`meft'"!="" & !`ismeff' {
		di in red "meff and meft options must be specified " /*
		*/ "at initial estimation"
		exit 198
	}

	tempname estname x b V Vsrs Vmsp

	qui test `formula' = 0
	scalar `x' = _result(6)

	matrix `b' = get(_b)
	matrix `V' = get(VCE)

/* Save deff, deft, meff matrices and other S_E_. */

	matrix `Vsrs' = S_E_Vsrs
	if `ismeff' { matrix `Vmsp' = S_E_Vmsp }
	local cmd  "$S_E_cmd"
	local depn "$S_E_depv"
	local fpc  "$S_E_fpc"
	local npsu "$S_E_npsu"
	local nstr "$S_E_nstr"
	if "`fpc'"!="" {
		tempname Vswr
		matrix `Vswr' = S_E_Vswr
	}

	nobreak {
		estimates hold `estname'
		capture noisily break {

			_getbv `x' `b' `V' `formula'

			local bb = `b'[1,1]
			local VV = `V'[1,1]

		/* Display formula. */

			noisily test `formula' = 0, notest

		/* Convert Vsrs, Vmsp, Vswr to C*Vsrs*C', etc. */

			Get_CVC `Vsrs' `formula'
			local Deff = `VV'/`Vsrs'[1,1]

			if `ismeff' {
				Get_CVC `Vmsp' `formula'
				local Meft = sqrt(`VV'/`Vmsp'[1,1])
			}

			if "`fpc'"!="" {
				Get_CVC `Vswr' `formula'
				local Deft = sqrt(`VV'/`Vswr'[1,1])
			}
			else local Deft = sqrt(`Deff')

		/* Post results for svy_dreg. */

			matrix post `b' `V' /* for matrix b = get(_b), etc. */

			if `Deff'!=. { matrix S_E_deff = (`Deff') }
			else	       matrix S_E_deff = (0)
			if `Deft'!=. { matrix S_E_deft = (`Deft') }
			else	       matrix S_E_deft = (0)

			if `ismeff' {
				if `Meft'!=. { matrix S_E_meft = (`Meft') }
				else	       matrix S_E_meft = (0)
			}

			global S_E_npsu "`npsu'"
			global S_E_nstr "`nstr'"
			global S_E_depv "`depn'"
			global S_E_cmd  "`cmd'"
			noisily {
				di
				svy_dreg, nohead level(`level') prob ci /*
				*/ `deff' `deft' `meff' `meft' `or' `rrr'
			}
		}
		local rc = _rc
		estimates unhold `estname'
		if `rc' { error `rc' }
	}
	global S_1 "`bb'"
	global S_2 = sqrt(`VV')
	global S_3 "`nstr'"
	global S_4 "`npsu'"
	global S_5 "`Deff'"
	global S_6 "`Deft'"
	global S_7 "`Meft'"
end

program define Get_CVC /* matrix_V `formula' */
	version 5.0
	local V "`1'"
	macro shift
	tempname w

	local dim = colsof(`V')
	local eqnames : coleq(`V')
	local cnames  : colnames(`V')
	matrix `w' = J(1,`dim',0)
	matrix coleq    `w' = `eqnames'
	matrix colnames `w' = `cnames'

	matrix post `w' `V'
	qui test `*' = 1
	scalar `w' = _result(6)

	matrix `V' = (0)
	if 1/`w'!=. { matrix `V'[1,1] = 1/`w' }
end
