*! version 1.0.0  21sep1998  STB-45 svy7
program define svytab
	version 5.0
	if substr("`1'",1,1)=="," | "`*'"=="" {
		if "$S_E_cmd"!="svytab" {
			error 301
		}
		Display `*'  /* display results */
		exit
	}
	nobreak {
		capture noisily break {
			tempvar doit subvar

			SvyParse `doit' `subvar' `*'

			local dopt "$S_VYdopt" /* display options */

			SvyTab `doit' `subvar'
		}
		if _rc {
			local rc = _rc
			macro drop S_VY*
			exit `rc'
		}
	}

	Display, `dopt'  /* display results */
end

program define SvyTab
	local doit   "`1'"
	local subvar "`2'"

	tempname /* matrices */ Obs b V Vdeff cstub rstub b0 row col /*
	*/                      Vrow Vcol Vfrow Vfcol X1 X2 D Da
	tempname /* scalars  */ s zero Xp Xlr Wlr Wp tr tr2 tra tr2a deff total
	tempvar cat

	if "$S_VYwgt"!="" {
		local wt "[iw=$S_VYexp]"
	}

/* Set-up for inclusion of tab() variable. */

	if "$S_VYtab"!="" {
		local mult "$S_VYtab*"
		local type "ratio"
		Total `total' $S_VYtab `doit' `subvar'
	}
	else	local type "mean"

/* Generate 0/1 dummies. */

	quietly {
		sort `doit' $S_VYvar1 $S_VYvar2
		by `doit' $S_VYvar1 $S_VYvar2: gen byte `cat' = (_n==1) /*
		*/ if `doit'

		tab $S_VYvar1 $S_VYvar2 if `doit', $S_VYmiss matcell(`Obs') /*
		*/ matrow(`rstub') matcol(`cstub')
		mat `rstub' = `rstub''
		local nrow = _result(2)
		local ncol = _result(3)

		replace `cat' = sum(`cat') if `doit'
		local ncat = `cat'[_N]

		local k 1
		while `k' <= `ncat' {
			tempvar x
			gen byte `x' = `mult'(`cat'==`k') if `doit'
			local vars "`vars' `x' $S_VYtab"
			local vt   "`vt' `x'"
			local k = `k' + 1
		}

		if "$S_VYse"=="row" | "$S_VYse"=="column"  {
			if "$S_VYse"=="row" {
				local var $S_VYvar1
				local colo "*"
			}
			else {
				local var $S_VYvar2
				local rowo "*"
			}
			tempvar catx
			sort `doit' `var'
			by `doit' `var': gen byte `catx' = (_n==1) /*
			*/ if `doit'
			replace `catx' = sum(`catx') if `doit'
			local ncatx = `cat'[_N]
			local i 1
			while `i' <= `ncatx' {
				tempvar x`i'
				gen byte `x`i'' = `mult'(`catx'==`i') if `doit'
				local i = `i' + 1
			}
			local i 1
			local j 1
			local k 1
			while `k' <= `ncat' {
				tempvar x
				gen byte `x' = `mult'(`cat'==`k') if `doit'

				while `Obs'[`i',`j'] == 0 {
					local j = mod(`j',`ncol')+1
					local i = cond(`j'==1,`i'+1,`i')
				}

				`rowo' local vs "`vs' `x' `x`i''"
				`colo' local vs "`vs' `x' `x`j''"

				local k = `k' + 1
				local j = mod(`j',`ncol')+1
				local i = cond(`j'==1,`i'+1,`i')
			}
		}
	}

/* Put value labels into stub vectors. */

	ValueLab $S_VYvar1 `rstub' 1
	ValueLab $S_VYvar2 `cstub' 2

/* Call to _svy for point estimates and variance of proportions. */

	if "$S_VYse"!="count" {
		local opts "vsrs(`Vdeff') $S_VYsrss"
	}
	_svy `vars' `wt' if `doit', type(`type') $S_VYopt /*
	*/ b(`b') v(`V') `opts'

	local  n        = _result(1)
	global S_VYnobs = _result(1)
	global S_VYnstr = _result(2)
	global S_VYnpsu = _result(3)
	global S_VYnpop = _result(4)

	if "$S_VYtab"=="" {
		if "$S_VYsub"=="" {
			scalar `total' = _result(4)
		}
		else	scalar `total' = _result(7)
	}

	if "$S_VYsub"!="" {
		local  n        = _result(1)
		global S_VYosub = _result(6)
		global S_VYnsub = _result(7)
	}

/* Get variance of totals. */

	if "$S_VYwald"!="" | "$S_VYse"=="count" {
		if "$S_VYse"=="count" {
			tempname bs
			local topts "b(`bs') vsrs(`Vdeff') $S_VYsrss"
		}
		tempname Vt
		_svy `vt' `wt' if `doit', type(total) $S_VYopt /*
		*/ v(`Vt') `topts'
	}

/* Get variance estimates for row or column proportions. */

	if "$S_VYse"=="row" | "$S_VYse"=="column" {
		tempname bs Vs
		_svy `vs' `wt' if `doit', type(ratio) $S_VYopt /*
		*/ b(`bs') v(`Vs')
	}

/* If `ncat'!=`nrow'*`ncol', then zeros need to be added to `b'. */

	if `ncat'!=`nrow'*`ncol' {
		AddZeros `Obs' `b' `V' `Vdeff' `Vt' `bs' `Vs'
		local ncat = `nrow'*`ncol'
	}

/* Get marginal row and column sums. */

	Marginal `nrow' `ncol' `b' `row' `col'

/* Get variance estimates for margins. */

	if "$S_VYse"!="count" {
		VMargin `nrow' `ncol' `V' `Vrow' `Vcol'
	}
	else	VMargin `nrow' `ncol' `Vt' `Vrow' `Vcol'

	VMargin `nrow' `ncol' `Vdeff' `Vfrow' `Vfcol'

/* Get expected values of proportions assuming independence: b0 = pi.*p.j. */

	Getb0 `row' `col' `b0'

/* `zero' = true if there is a zero in marginal totals (sum of weights must be
   zero for this to occur).
*/
	ChkZero `row' `col' `zero'

/* `one' = true if there is only one row or column. */

	local one = (`nrow'==1 | `ncol'==1)

	if !`zero' & !`one' {

/* Compute unadjusted statistics. */

	/* Pearson statistic. */

		Pearson `n' `b' `b0' `Xp'

	/* Likelihood ratio statistic. */

		LikeRat `n' `b' `b0' `Xlr'

	/* Get contrasts for test of independence. */

		IndCon `nrow' `ncol' `X1' `X2'

/* Compute adjustment factors and Wald tests. */

	/* Compute design effects matrix D using b0. */

		DeffMat `n' `b0' `V' `X2' `D' `tr' `tr2'

	/* Compute design effects matrix D using b. */

		DeffMat `n' `b' `V' `X2' `Da' `tra' `tr2a'

	/* Check against other methods.  COMMENTED OUT.  FOR TESTING ONLY.
        *
        *	Check `tr' `tra' `b' `b0' `V' `row' `col' `X1' `X2' `D' `Da'
	*/

	/* Standard log-linear Wald test. */

		LLWald `b' `b' `V' `X2' `Wlr'

	/* Pearson Wald test. */

		if "$S_VYwald"!="" {
			PearWald `b' `Vt' `total' `row' `col' `Wp'
		}
	}
	else	SetMiss `Xp' `Xlr' `tr' `tr2' `tra' `tr2a' `Wlr' `Wp'

/* Mean generalized deff and C.V. of eigenvalues. */

	local dfnom = (`nrow'-1)*(`ncol'-1)
	local deff = `tr'/`dfnom'
	local cv = sqrt(`dfnom'*`tr2'/`tr'^2 - 1)

/*------------------------------ Save results ------------------------------*/

/* Post `bs' and `Vs'. */

	if "$S_VYse"=="" {
		tempname bs
		mat `bs' = `b' /* `bs' destroyed by post; we want to save `b' */
		local Vs "`V'"
	}
	else if "$S_VYse"=="count" {
		local Vs  "`Vt'"
	}

	LabelMat `nrow' `ncol' `b' `bs' `Vs'

	local dof = $S_VYnpsu - $S_VYnstr

	mat post `bs' `Vs', dof(`dof') obs($S_VYnobs) depn("svytab")

/* Adjust and save Pearson and LR statistics. */

	MakeStat `dfnom' `tr'  `tr2'  `Xp'  X
	MakeStat `dfnom' `tra' `tr2a' `Xp'  Y
	MakeStat `dfnom' `tr'  `tr2'  `Xlr' L
	MakeStat `dfnom' `tra' `tr2a' `Xlr' M
	MakeFull `dfnom' `tr'  `tr2'  `Xp'  F

/* Adjust and save Wald tests. */

	MakeWald `dfnom' `Wlr' T
	if "$S_VYwald"!="" {
		MakeWald `dfnom' `Wp' W
	}

/* Save other results. */

	SvySave `nrow' `ncol' `ncat' `total' `zero' `deff' `cv' /*
	*/ `Obs' `b' `rstub' `cstub' `Vrow' `Vcol' `Vdeff' `Vfrow' `Vfcol'
end

program define MakeStat
	local dfnom "`1'"
	local tr    "`2'"
	local tr2   "`3'"
	local stat  "`4'"
	local name  "`5'"

	global S_E_`name'chi = `stat' /* uncorrected statistic */

	local df1 "(`tr'^2/`tr2')"

	global S_E_`name'F = `stat'/`tr'
	global S_E_`name'df1 = `df1'
	global S_E_`name'df2 = `df1'*($S_VYnpsu - $S_VYnstr)
	global S_E_`name'p = /*
	*/ fprob(`df1',`df1'*($S_VYnpsu-$S_VYnstr),`stat'/`tr')
end

program define MakeFull /* Fuller et al. variant */
	local dfnom "`1'"
	local tr    "`2'"
	local tr2   "`3'"
	local stat  "`4'"
	local name  "`5'"

	tempname tr3 df1
	scalar `tr3' = `tr2'-`tr'^2/($S_VYnpsu-$S_VYnstr)
	if `tr3' < 0 { scalar `tr3' = . }
	scalar `df1' = min(`tr'^2/`tr3',`dfnom')

	global S_E_`name'chi = `stat'
	global S_E_`name'F = `stat'/`tr'
	global S_E_`name'df1 = `df1'
	global S_E_`name'df2 = $S_VYnpsu - $S_VYnstr
	global S_E_`name'p = fprob(`df1',$S_VYnpsu-$S_VYnstr,`stat'/`tr')
end

program define MakeWald
	local df1  "`1'"
	local chi  "`2'"
	local name "`3'"
	local dfv = $S_VYnpsu - $S_VYnstr

	global S_E_`name'chi = `chi'
	global S_E_`name'df1 `df1'
	global S_E_`name'df2 = `dfv'-`df1'+1

	global S_E_`name'F = (`dfv'-`df1'+1)*`chi'/(`df1'*`dfv')
	if ${S_E_`name'F} < 0 { global S_E_`name'F . }
	global S_E_`name'p = fprob(`df1',`dfv'-`df1'+1,${S_E_`name'F})

	global S_E_`name'uF = `chi'/`df1'  /* unadjusted */
	global S_E_`name'up = fprob(`df1',`dfv',`chi'/`df1')
end

program define Pearson
	local n  "`1'"
	local b  "`2'"
	local b0 "`3'"
	local X  "`4'"

	tempname A B
	mat `A' = diag(`b0')
	mat `A' = syminv(`A')
	mat `B' = `b' - `b0'
	mat `A' = `A'*`B''
	mat `A' = `B'*`A'
	scalar `X' = `n'*`A'[1,1]
end

program define LikeRat
	local n  "`1'"
	local b  "`2'"
	local b0 "`3'"
	local X  "`4'"

	local dim = colsof(`b')
	scalar `X' = 0
	local i 1
	while `i' <= `dim' {
		scalar `X' = `X' + `b'[1,`i']*log(`b'[1,`i']/`b0'[1,`i'])
		local i = `i' + 1
	}

	scalar `X' = 2*`n'*`X'
end

program define LLWald
	local b  "`1'"
	local b0 "`2'"
	local V  "`3'"
	local C  "`4'"
	local X  "`5'"

	tempname A B G logbi
	local dim = colsof(`b')
	mat `G' = J(`dim',1,0)
	local i 1
	while `i' <= `dim' {
		scalar `logbi' = log(`b'[1,`i'])
		if `logbi'==. {
			scalar `X' = .
			exit
		}
		mat `G'[`i',1] = `logbi'
		local i = `i' + 1
	}

	mat `G' = `C''*`G'
	mat `B' = diag(`b0')
	mat `B' = syminv(`B')
	mat `A' = `V'*`B'
	mat `A' = `B'*`A'
	mat `A' = `A'*`C'
	mat `A' = `C''*`A'
	SymInv `A'
	mat `A' = `A'*`G'
	mat `A' = `G''*`A'

	scalar `X' = `A'[1,1]
end

program define PearWald
	local b     "`1'"
	local V     "`2'"
	local total "`3'"
	local row   "`4'"
	local col   "`5'"
	local X     "`6'"

	tempname A B W b0ij

	local nrow = colsof(`row')
	local ncol = colsof(`col')
	local dfnom = (`nrow'-1)*(`ncol'-1)
	local dim = `nrow'*`ncol'

	mat `A' = J(`dfnom',`dim',0)
	mat `B' = J(1,`dfnom',0)

	local k 1
	local i 1
	while `i' < `nrow' {
		local j 1
		while `j' < `ncol' {
			local l = `ncol'*(`i'-1) + `j'
			scalar `b0ij' = `row'[1,`i']*`col'[1,`j']
			mat `B'[1,`k'] = `b'[1,`l'] - `b0ij'
			local m 1
			local g 1
			while `g' <= `nrow' {
				local h 1
				while `h' <= `ncol' {

		if `g'==`i' | `h'==`j' {
			if `g'==`i' & `h'!=`j' {
				mat `A'[`k',`m'] = -`col'[1,`j'] + `b0ij'
			}
			else if `g'!=`i' & `h'==`j' {
				mat `A'[`k',`m'] = -`row'[1,`i'] + `b0ij'
			}
			else {
				mat `A'[`k',`m'] = /*
				*/ 1 - `row'[1,`i'] - `col'[1,`j'] + `b0ij'
			}
		}
		else	mat `A'[`k',`m'] = `b0ij'

					local m = `m' + 1
					local h = `h' + 1
				}
				local g = `g' + 1
			}
			local k = `k' + 1
			local j = `j' + 1
		}
		local i = `i' + 1
	}

	mat `W' = `V'*`A''
	mat `W' = `A'*`W'
	SymInv `W'
	mat `W' = `W'*`B''
	mat `W' = `B'*`W'

	scalar `X' = `total'^2*`W'[1,1]
end

program define DeffMat
	local n   "`1'"
	local b   "`2'"
	local V   "`3'"
	local C   "`4'"
	local D   "`5'"
	local tr  "`6'"
	local tr2 "`7'"

	tempname B
	mat `B' = diag(`b')
	mat `B' = syminv(`B')
	mat `D' = `V'*`B'
	mat `D' = `B'*`D'
	mat `D' = `D'*`C'
	mat `D' = `C''*`D'
	mat `B' = `B'*`C'
	mat `B' = `C''*`B'
	SymInv `B'
	mat `D' = `B'*`D'
	mat `D' = `n'*`D'

	scalar `tr' = trace(`D')
	mat `B' = `D'*`D'
	scalar `tr2' = trace(`B')
end

program define Sym
	local X "`1'" /* matrix in, replaced with exactly symmetric matrix */
	tempname Y
	mat `Y' = `X''
	mat `Y' = `Y' + `X' /* labels picked from right */
	mat `X' = 0.5*`Y'
end

program define SymInv
	local X "`1'" /* matrix in, replaced with inverse */
	Sym `X'
	mat `X' = syminv(`X')
end

program define Marginal
	local nrow "`1'"
	local ncol "`2'"
	local b    "`3'"
	local row  "`4'"
	local col  "`5'"

	tempname A B

	mat `A' = I(`nrow')
	mat `B' = J(1,`ncol',1)
	mat `A' = `A' # `B'
	mat `row' = `b'*`A''

	mat `A' = J(1,`nrow',1)
	mat `B' = I(`ncol')
	mat `A' = `A' # `B'
	mat `col' = `b'*`A''
end

program define VMargin
	local nrow "`1'"
	local ncol "`2'"
	local V    "`3'"
	local Vrow "`4'"
	local Vcol "`5'"

	tempname A B

	mat `A' = I(`nrow')
	mat `B' = J(1,`ncol',1)
	mat `A' = `A' # `B'
	mat `Vrow' = `V'*`A''
	mat `Vrow' = `A'*`Vrow'
	Sym `Vrow'

	mat `A' = J(1,`nrow',1)
	mat `B' = I(`ncol')
	mat `A' = `A' # `B'
	mat `Vcol' = `V'*`A''
	mat `Vcol' = `A'*`Vcol'
end

program define Getb0
	local row  "`1'"
	local col  "`2'"
	local b0   "`3'" /* output */

	tempname A B

/* Compute expected cell proportions. */

	mat `A' = `row''*`col'

/* Convert into a row vector. */

	mat `b0' = `A'[1,1...]
	local nrow = colsof(`row')
	local i 2
	while `i' <= `nrow' {
		mat `B' = `A'[`i',1...]
		mat `b0' = `b0' , `B'
		local i = `i' + 1
	}
end

program define ChkZero
	local row  "`1'"
	local col  "`2'"
	local zero "`3'"

	scalar `zero' = 0
	local nrow = colsof(`row')
	local i 1
	while `i' <= `nrow' {
		scalar `zero' = `zero' | (`row'[1,`i']==0)
		local i = `i' + 1
	}
	local ncol = colsof(`row')
	local i 1
	while `i' <= `ncol' {
		scalar `zero' = `zero' | (`col'[1,`i']==0)
		local i = `i' + 1
	}
end

program define AddZeros
	local cell "`1'"
	macro shift
	local nrow = rowsof(`cell')
	local ncol = colsof(`cell')
	local k 1
	local i 1
	while `i' <= `nrow' {
		local j 1
		while `j' <= `ncol' {
			if `cell'[`i',`j'] == 0 {
				local m 1
				while "``m''"!="" {
					PutZero ``m'' `k'
					local m = `m' + 1
				}
			}
			local k = `k' + 1
			local j = `j' + 1
		}
		local i = `i' + 1
	}
end

program define PutZero
	local A "`1'"
	local i "`2'"

	tempname B Z

	if `i' <= colsof(`A') {
		mat `B' = `A'[.,`i'...]
		local matAB "mat `A' = `A' , `B'"
	}

	local dim = rowsof(`A')
	mat `Z' = J(`dim',1,0)
	local i1 = `i' - 1

	if `i1' >= 1 {
		mat `A' = `A'[.,1..`i1']
		mat `A' = `A' , `Z'
	}
	else	mat `A' = `Z'

	`matAB'

	if `dim' == 1 { exit }

	if `i' <= `dim' {
		mat `B' = `A'[`i'...,.]
		local matAB "mat `A' = `A' \ `B'"
	}

	local dim = `dim' + 1
	mat `Z' = J(1,`dim',0)

	if `i1' >= 1 {
		mat `A' = `A'[1..`i1',.]
		mat `A' = `A' \ `Z'
	}
	else	mat `A' = `Z'

	`matAB'
end

program define IndCon
	local r  "`1'"
	local c  "`2'"
	local X1 "`3'"
	local X2 "`4'"

	tempname A X J

	local r1 = `r' - 1
	local c1 = `c' - 1

/* Build first `r'-1 columns: dummies for main effects of first variable. */

	mat `A' = I(`r1')
	mat `J' = J(1,`r1',-1)
	mat `A' = `A' \ `J'
	mat `J' = J(`c',1,1)
	mat `X1' = `A' # `J'

/* Build next `c'-1 columns: dummies for main effects of second variable. */

	mat `A' = I(`c1')
	mat `J' = J(1,`c1',-1)
	mat `A' = `A' \ `J'
	mat `J' = J(`r',1,1)
	mat `X' = `J' # `A'
	mat `X1' = `X1' , `X'

/* Build last (`r'-1)*(`c'-1) columns: interaction terms. */

	mat `X2' = I(`r1')
	mat `X2' = `X2' # `A'
	mat `J'  = J(1,`r1',-1)
	mat `A'  = `J' # `A'
	mat `X2' = `X2' \ `A'
end

program define LabelMat
	local nrow "`1'"
	local ncol "`2'"
	macro shift 2
	local i 1
	while `i' <= `nrow' {
		local j 1
		while `j' <= `ncol' {
			local names "`names' p`i'`j'"
			local j = `j' + 1
		}
		local i = `i' + 1
	}
	local i 1
	while "``i''"!="" {
		mat colnames ``i'' = `names'
		if rowsof(``i'') > 1 {
			mat rownames ``i'' = `names'
		}
		local i = `i' + 1
	}
end

program define ValueLab
	local var  "`1'"
	local stub "`2'"
	local numb "`3'"
	local dim = colsof(`stub')

	local lab : value label `var'
	if "`lab'"=="" { exit }

	local i 1
	while `i' <= `dim' {
		local x = `stub'[1,`i']
		local xlab : label `lab' `x'
		if "`xlab'"=="`x'" {
			local list "`list' hoborxqc" /* flag for not labeled */
		}
		else {
			local xlab = trim(substr("`xlab'",1,8))
			local sp = index("`xlab'"," ")
			if `sp' == 0 {
				local list "`list' `xlab'"
			}
			else { /* replace blanks with "_" */
				RepBlank "`xlab'"
				local list "`list' $S_1"
			}
		}
		local i = `i' + 1
	}

	mat colnames `stub' = `list'
	global S_VYlab`numb' "label"
end

program define RepBlank /* replaces blanks with "_" */
	local str "`1'"
	local i 1
	while `i' <= 8 {
		local sp = index("`str'"," ")
		if `sp' == 0 {
			global S_1 "`str'"
			exit
		}
		local str = substr("`str'",1,`sp'-1) + "_"  /*
		*/ + substr("`str'",`sp'+1,.)

		local i = `i' + 1
	}
end

program define SetMiss
	local i 1
	while "``i''"!="" {
		scalar ``i'' = .
		local i = `i' + 1
	}
end

program define Total
	local total  "`1'"
	local y      "`2'"
	local doit   "`3'"
	local subvar "`4'"

	quietly {
		if "$S_VYwgt"!="" {
			tempvar x
			gen double `x' = ($S_VYexp)*`y'
		}
		else local x "`y'"

		if "$S_VYsub"=="" {
			summarize `x' if `doit', meanonly
		}
		else	summarize `x' if `doit' & `subvar', meanonly

		scalar `total' = _result(18)
	}
end

program define VectoMat
	local A    "`1'"
	local nrow "`2'"
	local ncol "`3'"
	local New  "`4'"

	tempname row

	mat `New' = `A'[1,1..`ncol']
	local i = `ncol' + 1
	while `i' <= `nrow'*`ncol' {
		local end = `i' + `ncol' - 1
		mat `row' = `A'[1,`i'..`end']
		mat `New' = `New' \ `row'
		local i = `end' + 1
	}
end

/*----------------------------- Parse program --------------------------------*/

program define SvyParse
	local doit   "`1'"  /* mark variable                       */
	local subvar "`2'"  /* subpop category tempvar (if needed) */
	macro shift 2

/* Parse. */

	local varlist "req ex min(2) max(2)"
	local weight "pweight iweight noprefix"
	local if "opt"
	local in "opt"
	#delimit ;
	local options "STRata(string) PSU(string) FPC(string) SUBpop(string)
		       SRSsubpop MISSing TAB(string)
		       PEArson NULl LR WALD LLWALD noADJust FULLER
		       COUnt CELl ROW COLumn SE CI DEFF DEFT OBS
		       noLABel noMARGinals PERcent PROPortion
		       Level(int $S_level) FORmat(string) VERTical" ;
	#delimit cr
	parse "`*'"

	if "`null'"!="" & "`pearson'`lr'"=="" & "`wald'`llwald'"!="" {
		di in red "null option modifies pearson and lr options only"
		exit 198
	}
	if "`adjust'"!="" & "`wald'`llwald'"=="" {
		di in red /*
		*/ "noadjust option modifies wald and llwald options only"
		exit 198
	}
	local ncell : word count `obs' `se' `deff' `deft'
	if "`ci'"!="" & "`vertical'"!="" & `ncell' > 2 {
		di in red "only 2 of se, deff, deft, and obs can " /*
		*/ "be specified when ci and vertical" _n "specified"
		exit 198
	}
	if "`ci'"!="" { local ncell = `ncell' + 1 }
	if "`vertical'"=="" & `ncell' > 4 {
		di in red "only 4 of se, ci, deff, deft, and obs can " /*
		*/ "be specified"
		exit 198
	}
	if "`format'"!="" {
		quietly di `format' 0
		local format "format(`format')"
	}
	if `level' < 10 | `level' > 99 {
		di in red "level() must be between 10 and 99 inclusive"
		exit 198
	}
	if "`cell'`count'`row'`column'"=="" {
		local cell cell
	}
	if "`se'`ci'`deff'`deft'"!="" {
		local nopts : word count `cell' `count' `row' `column'
		if `nopts' > 1 {
			local opt : word 1 of `se' `deff' `deft'
			di in red "only one of cell, count, row, or column " /*
			*/ "can be specified when `opt' specified"
			exit 198
		}
	}
	if "`percent'"!="" & "`proport'"!="" {
		di in red "both percent and proportion cannot be specified"
		exit 198
	}
	if "`srssubp'"!="" & "`subpop'"=="" {
		di in red "srssubpop can only be specified when subpop() " /*
		*/	"is specified"
		exit 198
	}
	if "`subpop'"!="" {
		capture confirm variable `subpop'
		if _rc {
			di in red "subpop() must specify a variable name"
			exit 198
		}
		unabbrev `subpop'
		local subpop "$S_1"
		if $S_2 > 1 {
			di in red "only one variable allowed in subpop() " /*
			*/ "option"
			exit 198
		}
	}
	if "`tab'"!="" {
		capture confirm variable `tab'
		if _rc {
			di in red "tab() must specify a variable name"
			exit 198
		}
		unabbrev `tab'
		local tab "$S_1"
		if $S_2 > 1 {
			di in red "only one variable allowed in tab() " /*
			*/ "option"
			exit 198
		}
	}

/* Set global macros. */

	global S_VYvar1 : word 1 of `varlist'
	global S_VYvar2 : word 2 of `varlist'

	global S_VYdopt `pearson' `null' `lr' `wald' `llwald' /*
	*/ `adjust' `fuller' /*
	*/ `label' `se' `deff' `deft' `margina' `percent' /*
	*/ `proport' `cell' `count' `row' `column' level(`level') `ci' /*
	*/ `format' `vertica' `obs'

	if "`se'`ci'`deff'`deft'"!="" {
		global S_VYse "`count'`row'`column'"
	}
	global S_VYwald "`wald'"
	global S_VYmiss "`missing'"
	global S_VYtab  "`tab'"
	global S_VYsrss "`srssubp'"
	global S_VYopt  /* erase macro */

/* Get weights. */

	if "`exp'"=="" {
		svy_get pweight, optional
		local exp "$S_1"
	}
	else if "`weight'"=="pweight" { /* try to varset pweight variable */
		capture confirm variable `exp'
		if _rc==0 {
			svy_get pweight `exp'
			local exp "$S_1"
		}
	}
	if "`exp'"!="" {
		global S_VYexp "`exp'"
		if "`weight'"!="" { global S_VYwgt "`weight'" }
		else		    global S_VYwgt  pweight

		capture confirm variable `exp'
		if _rc {
			tempvar `w'
			qui gen double `w' = `exp'
		}
		else	local w "`exp'"
	}

/* Get strata, psu, and fpc. */

	svy_get strata `strata', optional
	global S_VYstr "$S_1"
	if "$S_VYstr"!="" {
		global S_VYopt "$S_VYopt str($S_VYstr)"
	}

	svy_get psu `psu', optional
	global S_VYpsu "$S_1"
	if "$S_VYpsu"!="" {
		global S_VYopt "$S_VYopt psu($S_VYpsu)"
	}

	svy_get fpc `fpc', optional
	global S_VYfpc "$S_1"
	if "$S_VYfpc"!="" {
		global S_VYopt "$S_VYopt fpc($S_VYfpc)"
	}

/* Mark. */

	mark `doit' `if' `in'

/* Check for negative weights if pweights. */

	if "$S_VYwgt"=="pweight" {
		capture assert `w' >= 0 if `doit'
		if _rc { error 402 }
	}

/* Markout. */

	markout `doit' `w' $S_VYfpc `subpop' `tab'
	markout `doit' $S_VYstr $S_VYpsu, strok

	if "`missing'"=="" {
		markout `doit' $S_VYvar1 $S_VYvar2
	}

/* Compute total #obs. */

	qui count if `doit'
	if _result(1) == 0 { error 2000 }
	global S_VYnobs = _result(1)

	if "`subpop'"=="" { exit }

/* Only here if subpop() specified. */

	qui count if `subpop'!=0 & `doit'
	if _result(1) == 0 {
		di in red "no observations in subpop() " /*
		*/ "subpopulation" _n /*
		*/ "subpop() = 1 indicates observation in " /*
		*/ "subpopulation" _n /*
		*/ "subpop() = 0 indicates observation not in " /*
		*/ "subpopulation"
		exit 461
	}
	if _result(1) == $S_VYnobs {
		di in blu _n "Note: subpop() subpopulation is " /*
		*/ "same as full population" _n /*
		*/ "subpop() = 1 (or nonzero) indicates " /*
		*/ "observation in subpopulation" _n /*
		*/ "subpop() = 0 indicates observation not in " /*
		*/ "subpopulation"
		local samemsg 1
	}
	qui count if `subpop'!=1 & `subpop'!=0 & `doit'
	if _result(1) > 0 {
		if "`samemsg'"=="" {
			di in blu _n "Note: subpop() takes on " /*
			*/ "values other than 0 and 1" _n /*
			*/ "subpop() ~= 0 indicates subpopulation"
		}
		global S_VYsub "`subpop'~=0"
	}
	else    global S_VYsub "`subpop'==1"

	qui gen byte `subvar' = (`subpop'!=0) if `doit'

	global S_VYopt "$S_VYopt by(`subvar') nby(1)"
end

/*--------------------------- Save results program ---------------------------*/

program define SvySave
	global S_E_nrow "`1'"  /* # of rows                             */
	global S_E_ncol "`2'"  /* # of columns                          */
	global S_E_ncat "`3'"  /* # of categories = $S_E_nrow*$S_E_ncol */
	scalar S_E_tot  =`4'   /* S_E_npop or total of tab variable     */
	global S_E_zero =`5'   /* = true if marginal zero in table      */
	global S_E_deff "`6'"  /* mean deff eigenvalue                  */
	global S_E_cv   "`7'"  /* c.v. of deff eigenvalues              */

	matrix S_E_cobs =`8'   /* cell # of observations                */
	VectoMat `9' `1' `2' S_E_prop /* cell proportions in matrix     */
	matrix S_E_row  =`10'  /* row stub                              */
	matrix S_E_col  =`11'  /* column stub                           */
	matrix S_E_Vrow =`12'  /* variance of row margins               */
	matrix S_E_Vcol =`13'  /* variance of column margins            */
	MakeDeff deff deft `14' /* make matrices S_E_deff and S_E_deft  */
	MakeDeff frow trow `15' S_E_Vrow /* matrices S_E_frow and S_E_trow */
	MakeDeff fcol tcol `16' S_E_Vcol /* matrices S_E_fcol and S_E_tcol */

	global S_E_nobs "$S_VYnobs"
	global S_E_nstr "$S_VYnstr"
	global S_E_npsu "$S_VYnpsu"
	global S_E_npop "$S_VYnpop"
	global S_E_osub "$S_VYosub"
	global S_E_nsub "$S_VYnsub"
	global S_E_se   "$S_VYse"
	global S_E_wgt  "$S_VYwgt"
	global S_E_exp  "$S_VYexp"
	global S_E_str  "$S_VYstr"
	global S_E_psu  "$S_VYpsu"
	global S_E_fpc  "$S_VYfpc"
	global S_E_sub  "$S_VYsub"
	global S_E_var1 "$S_VYvar1"
	global S_E_var2 "$S_VYvar2"
	global S_E_vlb1 : variable label $S_E_var1
	global S_E_vlb2 : variable label $S_E_var2
	global S_E_lab1 "$S_VYlab1"
	global S_E_lab2 "$S_VYlab2"
	global S_E_tab  "$S_VYtab"
	global S_E_cmd  "svytab"

/* Erase macros. */

	macro drop S_VY*
end

program define MakeDeff
	local deff  "`1'" /* macro suffix for deff */
	local deft  "`2'" /* macro suffix for deft */
	local Vdeff "`3'"
	local V     "`4'"

	tempname v f
	if "`V'"!="" {
		matrix `v' = vecdiag(`V')
	}
	else {
		matrix `v' = get(VCE)
		matrix `v' = vecdiag(`v')
	}
	local dim  = colsof(`v')
	matrix S_E_`deff' = `v'
	matrix S_E_`deft' = `v'

	if "$S_VYfpc"!="" { /* remove fpc from `Vdeff' for deft (which is wr) */
		tempname c
		if "$S_VYsrss"=="" {
			scalar `c' = 1-$S_VYnobs/$S_VYnpop
		}
		else	scalar `c' = 1-$S_VYosub/$S_VYnsub
	}
	else	local c 1

	local i 1
	while `i' <= `dim' {
		scalar `f' = `v'[1,`i']/`Vdeff'[`i',`i']
		matrix S_E_`deff'[1,`i'] = cond(`f'!=., `f', 0)

		scalar `f' = sqrt(`c'*`f')
		matrix S_E_`deft'[1,`i'] = cond(`f'!=., `f', 0)

		local i = `i' + 1
	}
end

/*---------------------------- Display programs ------------------------------*/

program define Display
	#delimit ;
	local options "PEArson NULl LR WALD LLWALD noADJust FULLER
	               COUnt CELl ROW COLumn SE CI DEFF DEFT OBS
	               noLABel noMARGinals PERcent PROPortion
	               Level(int $S_level) FORmat(string) VERTical" ;
	#delimit cr
	parse "`*'"

/* Check for syntax errors. */

	if "`null'"!="" & "`pearson'`lr'"=="" & "`wald'`llwald'"!="" {
		di in red "null option modifies pearson and lr options only"
		exit 198
	}
	if "`adjust'"!="" & "`wald'`llwald'"=="" {
		di in red /*
		*/ "noadjust option modifies wald and llwald options only"
		exit 198
	}
	if "`wald'"!="" & "$S_E_Wchi"=="" {
		di in red "wald not available on redisplay" _n /*
		*/ "it must be specified at run time"
		exit 198
	}
	if "`format'"!="" {
		quietly di `format' 0
	}
	if `level' < 10 | `level' > 99 {
		di in red "level() must be between 10 and 99 inclusive"
		exit 198
	}
	if "`cell'`count'`row'`column'"=="" {
		local cell cell
	}
	if "`se'`ci'`deff'`deft'"!="" {
		local nopts : word count `cell' `count' `row' `column'
		if `nopts' > 1 {
			local opt : word 1 of `se' `deff' `deft'
			di in red "only one of cell, count, row, or column " /*
			*/ "can be specified when `opt' specified"
			exit 198
		}
		if !( "$S_E_se"=="`count'`row'`column'" /*
		*/   | ("$S_E_se"=="" & "`cell'"!="") ) {

			if "$S_E_se"=="" { local didse "cell" }
			else		   local didse $S_E_se

			if "`se'"!="" {
				di in red "standard errors are only " /*
				*/ "available for `didse's" _n /*
				*/ "to compute `cell'`count'`row'`column' " /*
				*/ "standard errors, rerun command with " /*
				*/ "`cell'`count'`row'`column' and se options"
				exit 111
			}
			if "`ci'"!="" {
				di in red "confidence intervals are only " /*
				*/ "available for `didse's" _n /*
				*/ "to compute `cell'`count'`row'`column' " /*
				*/ "confidence intervals, rerun command " /*
				*/ "with `cell'`count'`row'`column' and " /*
				*/ "ci options"
				exit 111
			}

			local deff : word 1 of `deff' `deft'

			di in red "`deff' is only available for `didse's" _n /*
			*/ "to compute `cell'`count'`row'`column' `deff', " /*
			*/ "rerun command with `cell'`count'`row'`column' " /*
			*/ "and `deff' options"
			exit 111
		}
	}
	if "`percent'"!="" & "`proport'"!="" {
		di in red "both percent and proportion cannot be specified"
		exit 198
	}

/* Display header. */

	svy_head $S_E_nobs $S_E_nstr $S_E_npsu $S_E_npop /*
	*/ "$S_E_osub" "$S_E_nsub" "$S_E_wgt" "$S_E_exp" "$S_E_str" /*
	*/ "$S_E_psu" "$S_E_fpc" "$S_E_sub" "dash"

/* Display tabulation. */

	DispTab "`label'" "`se'" "`deff'" "`deft'" "`margina'" "`percent'" /*
	*/ "`proport'" "`cell'" "`count'" "`row'" "`column'" "`level'" "`ci'" /*
	*/ "`format'" "`vertica'" "`obs'"

/* Display error and warning messages. */

	if $S_E_zero {
		di _n in blu "  Table contains a zero in the marginals." _n /*
		*/ "  Statistics cannot be computed."
	}
	if $S_E_nrow == 1 {
		di _n in blu "  Only one row category." _n /*
		*/ "  Statistics cannot be computed."
	}
	if $S_E_ncol == 1 {
		di _n in blu "  Only one column category." _n /*
		*/ "  Statistics cannot be computed."
	}
	if $S_E_npsu - $S_E_nstr < ($S_E_nrow - 1)*($S_E_ncol - 1) {
		di _n in blu "  Note:  variance estimate degrees of freedom " /*
		*/ "= " in ye $S_E_npsu - $S_E_nstr _n in blu /*
		*/ "         are less than" _n /*
		*/ "         nominal table degrees of freedom = " /*
		*/ in ye ($S_E_nrow - 1)*($S_E_ncol - 1)
	}

/* Display statistics. */

	if "`pearson'`lr'`wald'`llwald'`fuller'"=="" {
		local pearson "pearson"
	}
	if "`pearson'"!="" {
		if "`null'"!="" {
			DispStat "Pearson:" Y X
		}
		else	DispStat "Pearson:" Y
	}
	if "`lr'"!="" {
		if "`null'"!="" {
			DispStat "Likelihood ratio:" M L
		}
		else	DispStat "Likelihood ratio:" M
	}
	if "`fuller'"!="" {
		DispStat "Pearson (Fuller version):" F
	}
	if "`wald'"!="" {
		DispWald "Wald (Pearson):" W `adjust'
	}
	if "`llwald'"!="" {
		DispWald "Wald (log-linear):" T `adjust'
	}

/* Display mean generalized deff and cv. */

	if "`deff'`deft'"!="" {
		di _n in gr "  Mean generalized deff" _col(35) "= " in ye /*
		*/ %9.4f $S_E_deff _n in gr "  CV of generalized deffs" /*
		*/ _col(35) "= " in ye %9.4f $S_E_cv
	}

/* Display FPC warning. */

	if "$S_E_fpc"!="" { /* print FPC note */
		di _n in blu "Finite population correction (FPC) assumes " /*
		*/ "simple random sampling without " _n /*
		*/ "replacement of PSUs within each stratum with no " /*
		*/ "subsampling within PSUs."
	}
end

program define DispTab
	local label   "`1'"
	local se      "`2'"
	local deff    "`3'"
	local deft    "`4'"
	local margina "`5'"
	local percent "`6'"
	local proport "`7'"
	local cell    "`8'"
	local count   "`9'"
	local row     "`10'"
	local column  "`11'"
	local level   "`12'"
	local ci      "`13'"
	local format  "`14'"
	local vertica "`15'"
	local obs     "`16'"

	if "`format'"=="" { local format "%6.0g" }

/* Preserve, then make data set for -tabdisp-. */

	preserve
	drop _all

	tempname matr matc

	local iii "int((_n-1)/$S_E_ncol)+1"  /* row position */
	local jjj "mod(_n-1,$S_E_ncol)+1"    /* column position */
	local b "S_E_prop[`iii',`jjj']"

	mat `matr' = J(1,$S_E_ncol,1)
	mat `matr' = `matr'*S_E_prop'
	mat `matc' = J(1,$S_E_nrow,1)
	mat `matc' = `matc'*S_E_prop

	quietly {

	/* Set obs. */

		if "`margina'"=="" {
			local Nr1 = $S_E_ncat + 1 /* start row marginals */
			local Nr2 = $S_E_ncat+$S_E_nrow /* end row marginals */
			local Nc1 = `Nr2' + 1     /* start column marginals */
			local Nc2 = `Nr2' + $S_E_ncol /* end column marginals */
			local N   = `Nc2' + 1     /* end */

			local total "total"
		}
		else	local N $S_E_ncat

		set obs `N'

	/* Make stubs of table. */

		gen double $S_E_var1 = S_E_row[1,`iii'] in 1/$S_E_ncat
		gen double $S_E_var2 = S_E_col[1,`jjj'] in 1/$S_E_ncat

		if "`margina'"=="" {
			replace $S_E_var1 = S_E_row[1,_n-`Nr1'+1] in `Nr1'/`Nr2'
			replace $S_E_var2 = S_E_col[1,_n-`Nc1'+1] in `Nc1'/`Nc2'
		}

	/* Make variable labels and value labels for stub variables. */

		if "`label'"=="" {
			label variable $S_E_var1 "$S_E_vlb1"
			label variable $S_E_var2 "$S_E_vlb2"

			if "$S_E_lab1"!="" { MakeLab $S_E_var1 S_E_row }
			if "$S_E_lab2"!="" { MakeLab $S_E_var2 S_E_col }
		}

	/* Handle display of missing values if necessary. */

		if S_E_row[1,$S_E_nrow]==. {
			FixMiss $S_E_var1 S_E_row[1,$S_E_nrow-1] /*
			*/ $S_E_ncat `Nr1' `Nr2'
		}
		if S_E_col[1,$S_E_ncol]==. {
			FixMiss $S_E_var2 S_E_col[1,$S_E_ncol-1] /*
			*/ $S_E_ncat `Nc1' `Nc2'
		}

	/* Make counts and proportions or percents. */

		local keyi 1

		if "`count'"!="" {
			tempvar xc
			gen double `xc' = S_E_tot*`b' in 1/$S_E_ncat

			if "`margina'"=="" {
				replace `xc' = S_E_tot*`matr'[1,_n-`Nr1'+1] /*
				*/ in `Nr1'/`Nr2'
				replace `xc' = S_E_tot*`matc'[1,_n-`Nc1'+1] /*
				*/ in `Nc1'/`Nc2'
				replace `xc' = S_E_tot in l
			}

			if "$S_E_wgt"!="" {
				local key`keyi' "weighted counts"
			}
			else	local key`keyi' "counts"
			local keyi = `keyi' + 1
		}

		if "`percent'"!="" {
			local porp 100 /* percent or proportion */
			local kporp "percentages"
		}
		else {
			local porp 1
			local kporp "proportions"
		}

		if "`cell'"!="" {
			tempvar xp
			gen double `xp' = `porp'*`b' in 1/$S_E_ncat

			if "`margina'"=="" {
				replace `xp' = `porp'*`matr'[1,_n-`Nr1'+1] /*
				*/ in `Nr1'/`Nr2'
				replace `xp' = `porp'*`matc'[1,_n-`Nc1'+1] /*
				*/ in `Nc1'/`Nc2'
				replace `xp' = `porp' in l
			}
			local key`keyi' "cell `kporp'"
			local keyi = `keyi' + 1
		}
		if "`row'"!="" {
			tempvar xrow
			gen double `xrow' = `porp'*`b'/`matr'[1,`iii'] /*
			*/ in 1/$S_E_ncat

			if "`margina'"=="" {
				replace `xrow' = `porp' in `Nr1'/`Nr2'
				replace `xrow' = `porp'*`matc'[1,_n-`Nc1'+1] /*
				*/ in `Nc1'/`Nc2'
				replace `xrow' = `porp' in l
			}
			local key`keyi' "row `kporp'"
			local keyi = `keyi' + 1
		}
		if "`column'"!="" {
			tempvar xcol
			gen double `xcol' = `porp'*`b'/`matc'[1,`jjj'] /*
			*/ in 1/$S_E_ncat

			if "`margina'"=="" {
				replace `xcol' = `porp'*`matr'[1,_n-`Nr1'+1] /*
				*/ in `Nr1'/`Nr2'
				replace `xcol' = `porp' in `Nc1'/`Nc2'
				replace `xcol' = `porp' in l
			}
			local key`keyi' "column `kporp'"
			local keyi = `keyi' + 1
		}

	/* From here to `obs', only one of count, cell, row, or column is
	   chosen.
	*/
		local keylast = `keyi' - 1
		local item "`key`keylast''"

		if "`count'"!="" { local porp 1 }

		if "`se'`ci'"!="" {
			tempvar V xse
			mat `V' = get(VCE)
			gen double `xse' = `porp'*sqrt(`V'[_n,_n]) /*
			*/ in 1/$S_E_ncat

			if "`margina'"=="" {
				if "`row'"=="" {
					replace `xse' = `porp'* /*
					*/ sqrt(S_E_Vrow[_n-`Nr1'+1, /*
					*/ _n-`Nr1'+1]) in `Nr1'/`Nr2'
				}
				if "`column'"=="" {
					replace `xse' = `porp'* /*
					*/ sqrt(S_E_Vcol[_n-`Nc1'+1, /*
				        */ _n-`Nc1'+1]) in `Nc1'/`Nc2'
				}
			}

			if "`se'"!="" {
				if "`vertica'"=="" {
					local key`keyi' /*
					*/ "(standard errors of `item')"
				}
				else {
					local key`keyi' /*
					*/ "standard errors of `item'"
				}
				local keyi = `keyi' + 1
			}
		}
		if "`ci'"!="" {
			tempname t
			tempvar lb ub
			scalar `t' = invt($S_E_npsu-$S_E_nstr,`level'/100)

			if "`count'"=="" {
				local x "`xp'`xrow'`xcol'"
				if `porp' == 100 {
					local x "(`x'/100)"
				}

				gen double `lb' = `porp'/(1 + /*
				*/ exp(-(log(`x'/(1-`x')) /*
				*/ - `t'*`xse'/(`porp'*`x'*(1-`x')))))

				gen double `ub' = `porp'/(1 + /*
				*/ exp(-(log(`x'/(1-`x')) /*
				*/ + `t'*`xse'/(`porp'*`x'*(1-`x')))))
			}
			else {
				gen double `lb' = `xc' - `t'*`xse'
				gen double `ub' = `xc' + `t'*`xse'
			}

			local xci "`lb' `ub'"

			if "`se'"=="" { local xse /* erase tempvar */ }

			if "`vertica'"=="" {
				local key`keyi' /*
				*/"[`level'% confidence intervals for `item']"
			}
			else {
				local key`keyi' /*
				*/ "lower `level'% confidence bounds for `item'"
				local keyi = `keyi' + 1
				local key`keyi' /*
				*/ "upper `level'% confidence bounds for `item'"
			}
			local keyi = `keyi' + 1
		}
		if "`vertica'"=="" & "`se'`ci'"!="" {
			if "`se'"=="" {
				local nose "*"
			}
			if "`ci'"=="" {
				local noci "*"
			}

			`nose' tempvar xxse
			`nose' gen str1 `xxse' = "" in 1
			`noci' tempvar xci
			`noci' gen str1 `xci' = "" in 1

			local i 1
			while `i' <= `N' {
				`nose' local ses : di `format' `xse'[`i']
				`nose' replace `xxse' = "("+trim("`ses'")+")" /*
				*/ in `i' if `xse'!=.

				`noci' local slb : di `format' `lb'[`i']
				`noci' local sub : di `format' `ub'[`i']
				`noci' replace `xci' = "["+trim("`slb'") /*
				*/ +","+trim("`sub'")+"]" in `i' /*
				*/ if `lb'!=. & `ub'!=.
				local i = `i' + 1
			}

			`nose' local xse "`xxse'"
		}
		if "`deff'"!="" {
			tempvar xdeff
			DeffVar `xdeff' f `Nr1' `Nr2' `Nc1' `Nc2' /*
			*/ "`margina'" "`row'" "`column'"
			local key`keyi' "deff for variances of `item'"
			local keyi = `keyi' + 1
		}
		if "`deft'"!="" {
			tempvar xdeft
			DeffVar `xdeft' t `Nr1' `Nr2' `Nc1' `Nc2' /*
			*/ "`margina'" "`row'" "`column'"
			local key`keyi' "deft for variances of `item'"
			local keyi = `keyi' + 1
		}
		if "`obs'"!="" {
			tempvar xobs
			gen long `xobs' = S_E_cobs[`iii',`jjj'] in 1/$S_E_ncat
			if "`margina'"=="" {
				tempname J
				mat `J' = J(1,$S_E_ncol,1)
				mat `J' = `J'*S_E_cobs'
				replace `xobs' = `J'[1,_n-`Nr1'+1] /*
				*/ in `Nr1'/`Nr2'
				mat `J' = J(1,$S_E_nrow,1)
				mat `J' = `J'*S_E_cobs
				replace `xobs' = `J'[1,_n-`Nc1'+1] /*
				*/ in `Nc1'/`Nc2'
				replace `xobs' = $S_E_nobs in l
			}
			local key`keyi' "number of observations"
			local keyi = `keyi' + 1
		}
	}

	local vars "`xc' `xp' `xrow' `xcol' `xse' `xci' `xdeff' `xdeft' `xobs'"

	tabdisp $S_E_var1 $S_E_var2, cell(`vars') `total' format(`format')

	if "$S_E_tab"!="" {
		di in gr "  Tabulated variable:  $S_E_tab" _n
	}

	di in gr "  Key:  " _c
	local col 1
	local i 1
	while `i' < `keyi' {
		di _col(`col') in ye "`key`i''"
		local col 9
		local i = `i' + 1
	}
end

program define DeffVar
	local var     "`1'"
	local ft      "`2'"
	local Nr1     "`3'"
	local Nr2     "`4'"
	local Nc1     "`5'"
	local Nc2     "`6'"
	local margina "`7'"
	local row     "`8'"
	local column  "`9'"

	quietly {
		gen double `var' = cond(S_E_def`ft'[1,_n]!=0, /*
		*/ S_E_def`ft'[1,_n],.) in 1/$S_E_ncat
		if "`margina'"=="" {
			if "`row'"=="" {
				replace `var' = cond( /*
				*/ S_E_`ft'row[1,_n-`Nr1'+1]!=0, /*
				*/ S_E_`ft'row[1,_n-`Nr1'+1],.) /*
				*/ in `Nr1'/`Nr2'
			}
			if "`column'"=="" {
				replace `var' = cond( /*
				*/ S_E_`ft'col[1,_n-`Nc1'+1]!=0, /*
				*/ S_E_`ft'col[1,_n-`Nc1'+1],.) /*
				*/ in `Nc1'/`Nc2'
			}
		}
	}
end

program define FixMiss
	local var "`1'"
	local missval = round((`2')+1,1)
	local N  "`3'"
	local N1 "`4'"
	local N2 "`5'"

	local lab : value label `var'
	if "`lab'"=="" {
		tempname lab
		label define `lab' `missval' "."
		label value `var' `lab'
	}
	else	label define `lab' `missval' "." , add

	qui replace `var' = `missval' if `var'==.&(_n<=`N'|(`N1'<=_n&_n<=`N2'))
end

program define MakeLab
	local var  "`1'"
	local stub "`2'"
	local dim = colsof(matrix(`stub'))
	local xlabs : colnames(`stub')
	parse "`xlabs'", parse(" ")

	tempname lab
	local i 1
	while `i' <= `dim' {
		local x = `stub'[1,`i']
		if "``i''"!="hoborxqc" {
			label define `lab' `x' "``i''", `add'
			local add "add"
		}
		local i = `i' + 1
	}
	if "`add'"!="" {
		label value `var' `lab'
	}
end

program define DispStat
	local title "`1'"
	local stat  "`2'"
	local null  "`3'"

	local col0  5 /* left margin */
	local col1 19 /* statistic   */
	local col2 35 /* equal sign  */
	local col3 51 /* p-value     */

	local dfnom = ($S_E_nrow-1)*($S_E_ncol-1)
	local df1 ${S_E_`stat'df1}
	local df2 ${S_E_`stat'df2}

	if `df1' != int(`df1') {
		local df1 "%4.2f `df1'"
	}
	if `df2' != int(`df2') {
		local df2 "%4.2f `df2'"
	}

	di _n in gr "  `title'"

	di in gr _col(`col0') "Uncorrected" _col(`col1') "chi2(" in ye /*
	*/ `dfnom' in gr ")" _col(`col2') "= " in ye %9.4f ${S_E_`stat'chi}

	if "`null'"!="" {
		local df1n ${S_E_`null'df1}
		local df2n ${S_E_`null'df2}

		if `df1n' != int(`df1n') {
			local df1n "%4.2f `df1n'"
		}
		if `df2n' != int(`df2n') {
			local df2n "%4.2f `df2n'"
		}

		di in gr _col(`col0') "D-B (null)" _col(`col1') "F(" in ye /*
		*/ `df1n' in gr "," in ye `df2n' in gr ")" _col(`col2') "= " /*
		*/ in ye %9.4f ${S_E_`null'F} _col(`col3') in gr "P = " in ye /*
		*/ %6.4f ${S_E_`null'p}
	}

	di in gr _col(`col0') "Design-based" _col(`col1') "F(" in ye `df1' /*
	*/ in gr "," in ye `df2' in gr ")" _col(`col2') "= " in ye %9.4f /*
	*/ ${S_E_`stat'F} _col(`col3') in gr "P = " in ye %6.4f ${S_E_`stat'p}
end

program define DispWald
	local title "`1'"
	local stat  "`2'"
	local unadj "`3'"

	local col0  5 /* left margin */
	local col1 19 /* statistic   */
	local col2 35 /* equal sign  */
	local col3 51 /* p-value     */

	di _n in gr "  `title'"

	di in gr _col(`col0') "Unadjusted" _col(`col1') "chi2(" in ye /*
	*/ ${S_E_`stat'df1} in gr ")" _col(`col2') "= " in ye %9.4f /*
	*/ ${S_E_`stat'chi}

	if "`unadj'"!="" {
		di in gr _col(`col0') "Unadjusted" _col(`col1') "F(" in ye /*
		*/ ${S_E_`stat'df1} in gr "," in ye $S_E_npsu-$S_E_nstr in gr /*
		*/ ")" _col(`col2') "= " in ye %9.4f ${S_E_`stat'uF} /*
		*/ _col(`col3') in gr "P = " in ye %6.4f ${S_E_`stat'up}
	}

	di in gr _col(`col0') "Adjusted" _col(`col1') "F(" in ye /*
	*/ ${S_E_`stat'df1} in gr "," in ye ${S_E_`stat'df2} in gr ")" /*
	*/ _col(`col2') "= " in ye %9.4f ${S_E_`stat'F} _col(`col3') /*
	*/ in gr "P = " in ye %6.4f ${S_E_`stat'p}
end

*! version 1.0.0  08aug1998
program define svy_head /* display header */
	version 5.0
	local nobs   "`1'"
	local nstr   "`2'"
	local npsu   "`3'"
	local npop   "`4'"
	local osub   "`5'"
	local nsub   "`6'"
	local wgt    "`7'"
	local exp    "`8'"
	local strata "`9'"
	local psu    "`10'"
	local fpc    "`11'"
	local subpop "`12'"
	local dash   "`13'"

	if "`wgt'"    == "" { local wgt    "pweight"        }
	if "`exp'"    == "" { local exp    "<none>"         }
	if "`strata'" == "" { local strata "<one>"          }
	if "`psu'"    == "" { local psu    "<observations>" }

	if "`dash'"!="" { di _n in gr _dup(78) "-" }
	else di

	#delimit ;
	di in gr "`wgt':" _col(11) "`exp'"
	   in gr _col(49) "Number of obs`fnote'" _col(68) "= "
	   in ye %9.0f `nobs' _n
	   in gr "Strata:" _col(11) "`strata'"
	   in gr _col(49) "Number of strata" _col(68) "= "
	   in ye %9.0f `nstr' _n
	   in gr "PSU:" _col(11) "`psu'"
	   in gr _col(49) "Number of PSUs" _col(68) "= "
	   in ye %9.0f `npsu' ;

	if "`fpc'"!="" { ;
		di in gr "FPC:" _col(11) "`fpc'"
		   in gr _col(49) "Population size" _col(68) "="
		   in ye %10.0g `npop' ;
	} ;
	else { ;
		di in gr _col(49) "Population size" _col(68) "="
		   in ye %10.0g `npop' ;
	} ;
	if "`subpop'"!="" { ;
		di in gr "Subpop.:" _col(11) "`subpop'$S_8"
		   _col(49) "Subpop. no. of obs" _col(68) "= "
		   in ye %9.0f `osub' _n
		   in gr _col(49) "Subpop. size" _col(68) "="
		   in ye %10.0g `nsub'
	} ;

	if "`dash'"!="" { di in gr _dup(78) "-" } ;
end ;

exit ;

/*-------------------------------- old code  --------------------------------*/

program define Check
	local tr   "`1'"
	local tra  "`2'"
	local b    "`3'"
	local b0   "`4'"
	local V    "`5'"
	local row  "`6'"
	local col  "`7'"
	local X1   "`8'"
	local X2   "`9'"
	local D    "`10'"
	local Da   "`11'"

	local nrow = colsof(`row')
	local ncol = colsof(`col')

	tempname A trc
	di in gr "tr(Ho)         = " in ye %12.8f `tr'
	di in gr "tr(Ha)         = " in ye %12.8f `tra'

	TraceD $S_VYnobs `nrow' `ncol' `b' `b0' `V' `trc'
	di in gr "tr(comparison) = " in ye %12.8f `trc' /*
	*/ %12.1e abs((`trc'-`tr')/`tr')

	Fuller `b0' `V' `row' `col' `A'
	scalar `trc' = trace(`A')
	di in gr "tr(Fuller)     = " in ye %12.8f `trc' /*
	*/ %12.1e abs((`trc'-`tr')/`tr')

	Nested `b0' `V' `X1' `X2' `A'
	scalar `trc' = trace(`A')
	di in gr "tr(Nested b0)  = " in ye %12.8f `trc' /*
	*/ %12.1e abs((`trc'-`tr')/`tr') %12.1e mreldif(`A',`D')

	Nested `b' `V' `X1' `X2' `A'
	scalar `trc' = trace(`A')
	di in gr "tr(Nested b)   = " in ye %12.8f `trc' /*
	*/ %12.1e abs((`trc'-`tra')/`tra') %12.1e mreldif(`A',`Da')
end

program define Nested /* With b0 as input, this program yields D with the same
                         trace(D) and trace(D^2) as DeffMat with b0, but D's are
                         different.  With b as input, gives same traces as
                         DeffMat with b (except when there are zeros in table).
		      */
	local b0 "`1'"
	local V  "`2'"
	local X1 "`3'"
	local X2 "`4'"
	local D  "`5'"

	tempname A P Xt2

/* Construct misspecified variance estimate `P' under Ho. */

	mat `P' = `b0''*`b0'
	mat `A' = diag(`b0')
	mat `P' = `A' - `P'

/* Project `X2' onto the orthogonal complement of `X1' space w.r.t. `P' norm. */

	ProjOper `X1' `P' `A'

	mat `Xt2' = `A'*`X2'

/* Compute generalized design effects matrix. */

	mat `A' = `P'*`Xt2'
	mat `A' = `Xt2''*`A'
	SymInv `A'
	mat `D' = `V'*`Xt2'
	mat `D' = `Xt2''*`D'
	mat `D' = `A'*`D'
	mat `D' = $S_VYnobs*`D'
end

program define Fuller /* This program yields D with the same trace(D) and
                         trace(D^2) as DeffMat with b0, but D's are different;
                         they are not even the same dimension.  When called
			 with b, gives something not related to other methods.
		      */
	local b0  "`1'"
	local V   "`2'"
	local row "`3'"
	local col "`4'"
	local D   "`5'"

	tempname A B X

	local nrow = colsof(`row')
	local ncol = colsof(`col')

/* Compute `X' matrix. */

	mat `A' = I(`nrow')
	mat `B' = `col''
	mat `X' = `A' # `B'
	mat `A' = I(`ncol')
	mat `B' = `row''
	mat `A' = `B' # `A'
	mat `X' = `X' , `A'
	local dim = `nrow' + `ncol' - 1
	mat `X' = `X'[1...,1..`dim']

/* Compute projection matrix. */

	mat `A' = diag(`b0')
	mat `A' = syminv(`A')

	ProjOper `X' `A' `D'

	mat `D' = `A'*`D'
	mat `D' = `D'*`V'
	mat `D' = $S_VYnobs*`D'
end

program define ProjOper /* returns P = I - X (X'WX)^-1 X'W */
	local X "`1'"
	local W "`2'"
	local P "`3'"
	tempname A
	mat `A' = `W'*`X'
	mat `A' = `X''*`A'
	SymInv `A'
	mat `A' = `A'*`X''
	mat `A' = `X'*`A'
	Sym `A'
	mat `A' = `A'*`W'
	local dim = colsof(`A')
	mat `P' = I(`dim')
	mat `P' = `P' - `A'
end

program define TraceD
	local n    "`1'"
	local nrow "`2'"
	local ncol "`3'"
	local b    "`4'"
	local b0   "`5'"
	local V    "`6'"
	local tr   "`7'"

	tempname A B row col Vrow Vcol

/* Get marginal row and column sums. */

	mat `A' = I(`nrow')
	mat `B' = J(1,`ncol',1)
	mat `A' = `A' # `B'
	mat `row' = `b'*`A''
	mat `Vrow' = `V'*`A''
	mat `Vrow' = `A'*`Vrow'

	mat `A' = J(1,`nrow',1)
	mat `B' = I(`ncol')
	mat `A' = `A' # `B'
	mat `col' = `b'*`A''
	mat `Vcol' = `V'*`A''
	mat `Vcol' = `A'*`Vcol'

	scalar `tr' = 0
	local i 1
	while `i' <= `nrow'*`ncol' {
		scalar `tr' = `tr' + `V'[`i',`i']/`b0'[1,`i']
		local i = `i' + 1
	}
	local i 1
	while `i' <= `nrow' {
		scalar `tr' = `tr' - `Vrow'[`i',`i']/`row'[1,`i']
		local i = `i' + 1
	}
	local i 1
	while `i' <= `ncol' {
		scalar `tr' = `tr' - `Vcol'[`i',`i']/`col'[1,`i']
		local i = `i' + 1
	}

	scalar `tr' = `n'*`tr'
end

/*---------------------------- end of old code ------------------------------*/

(1) Non-Wald statistics:

    X = Pearson with null misspecified variance
    Y = Pearson with observed misspecified variance
    L = LR      with null
    M = LR      with observed

    all these produce (with X, Y, L, or M in place of X below):

	S_E_Xchi    misspecified chi2
	S_E_XF      F-statistic: F = chi2/df1
	S_E_Xdf1    df1 = tr^2/tr2
	S_E_Xdf2    df2 = df1*(#psu - #strata)
	S_E_Xp      p-value for above F-statistic ~ F(df1,df2)

(2) Fuller variant:

    F = Pearson with null misspecified variance (X) using Fuller et al.'s
    formula.

	S_E_FF      F = chi2/df1 ~ F(df1,df2)
	S_E_Fdf1    df1 = <complex formula>
	S_E_Fdf2    df2 = #psu - #strata
	S_E_Fp      p-value for above F-statistic ~ F(df1,df2)

(3) Wald statistics:

    W = Pearson Wald
    T = log-linear Wald

    both of these produce (with W or T in place of W below):

	S_E_Wchi    chi2 statistic
	S_E_WF      adjusted F = (dfv-df1+1)*chi2/(df1*dfv)
	S_E_df1     (# rows - 1)*(# columns - 1)
	S_E_df2     df2 = dfv - df1 + 1, where dfv = #psu - #strata
	S_E_Wp      p-value for adjusted F-statistic ~ F(df1,df2)

	S_E_WuF     unadjusted F = chi2/df1
	S_E_Wup     p-value for unadjusted F-statistic ~ F(df1,dfv)

    SUDAAN Wald tests are S_E_WuF, S_E_Wup and S_E_TuF, S_E_Tup.

-------------------------------------------------------------------------------
<end of file>
