*! version 5.0.2  03dec1997
program define weib_lf 
	version 5.0
	local baug "`1'"
	local f "`2'"
	local g "`3'"
	local D "`4'"

	mac shift 4
	local options "FAST(string) *"
	parse "`*'"

	tempvar I L lnf
	tempname b ln_p s p

	matrix `b' = `baug'[1,"$EREGt:"]
matrix `b' = -1 * `b'
	matrix `ln_p' = `baug'[1,"ln_p:"]
	scalar `s' = `ln_p'[1,1]
	scalar `p' = exp(`s')

	/* note, we use p = exp(s), s=0 means p=1; s=ln(p) */

	quietly {
		matrix score double `I' = `b' if $EREGw
		gen double `L' = exp(`I')
		#delimit ;
		gen double `lnf' =
			-((`L'*$EREGt )^`p') +
			 ((`L'*$EREGt0)^`p') +
			$EREGd*(
				`I' + `s' +
				(`p'-1)*(`I'+ln($EREGt))
			) ;
		#delimit cr
capture assert `lnf'==. if $EREGw
if _rc==0 {
	scalar `f' = -1e+99
	exit
}
		replace `lnf' = sum($EREGw*`lnf')
		scalar `f' = `lnf'[_N] + $EREGa

		if "`fast'"=="0" { exit }

		tempvar Lt_p Lt0_p A B
		tempname g2 dbds dsds

		gen double `Lt_p' = (`L'*$EREGt)^`p' if $EREGw 
		gen double `Lt0_p'= (`L'*$EREGt0)^`p' if $EREGw 
		drop `L'

			/* gradient calculation */
			/* dL/db = Ax */
		gen double `A' = $EREGw*( `p'*( -`Lt_p' + `Lt0_p' + $EREGd) )

		local rhs : colnames(`b')
		parse "`rhs'", parse(" ")
		local n : word count `rhs'
		if "``n''"=="_cons" {
			local `n'
		}
		matrix vecaccum `g' = `A' `*'	/* g = dL/db */


			/* dL/ds = a mess = 1'B */


		gen double `B'= -`p'*`Lt_p'*(`I'+ln($EREGt))
		replace `B'=`B'+ `p'* `Lt0_p'*(`I'+ln($EREGt0)) if $EREGt0>0
		replace `B' = `B' + $EREGd*(1 + `p'*(`I'+ln($EREGt)))
		replace `lnf' = sum($EREGw*`B') 
					/* lnf holds dL/ds */

					/* put together dL/db dL/ds */
		matrix `g2' = J(1,1,0)
		matrix `g2'[1,1] = `lnf'[_N]
		matrix colnames `g' = $EREGt:
		matrix colnames `g2'= ln_p:_cons
matrix `g' = -1 * `g'
		matrix `g' = `g',`g2'

				/* 2nd derivs */
				/* d2L/db2 = X' diag(C) X, 
				   use lnf to hold diag(C)
				*/
		replace `lnf'=$EREGw*( `p'*`p'*( -`Lt_p' + `Lt0_p') )
		if "`*'"=="" {
			mat accum `D' = $EREGt [iw=`lnf']
			mat `D' = `D'[2,2]
		}
		else	mat accum `D' = `*' [iw=`lnf']
				/* `D' now contains d2L/db2 */

				/* d2L/dbds = A/p + mess */
/*
		replace `lnf' = (`A') - $EREGw*`p'*`p'*`Lt_p'*(`I'+ln($EREGt))
		replace `lnf' = `lnf' /*
				*/ + $EREGw*`p'*`p'*`Lt0_p'*(`I'+ln($EREGt0)) /*
				*/ if $EREGt0>0
replace `lnf' = -`lnf'
*/
		replace `lnf' = -(`A') + $EREGw*`p'*`p'*`Lt_p'*(`I'+ln($EREGt))
		replace `lnf' = `lnf' /*
				*/ - $EREGw*`p'*`p'*`Lt0_p'*(`I'+ln($EREGt0)) /*
				*/ if $EREGt0>0

		matrix vecaccum `dbds' = `lnf' `*'
				/* d2L/dbds in dbds */

				/* d2L/ds2 = 1'[(B-d) + mess] */

		replace `lnf' = (`B'-$EREGd) - /*
			*/ `p'*`p'*`Lt_p'*(`I'+ln($EREGt))^2
		replace `lnf' = `lnf' + /*
			*/ (`p')^2*`Lt0_p'*(`I'+ln($EREGt0))^2 /*
			*/ if $EREGt0>0
		replace `lnf' = sum($EREGw*`lnf')

		matrix colnames `D' = $EREGt:
		matrix rownames `D' = $EREGt:
		matrix colnames `dbds' = $EREGt:
		matrix rownames `dbds' = ln_p:_cons
		matrix `D' = `D' \ `dbds'
		matrix `dbds' = `dbds' '
		matrix `dsds' = J(1,1,0)
		matrix `dsds'[1,1] = `lnf'[_N]
		matrix `dbds' = `dbds' \ `dsds' 
		matrix `D' = `D' , `dbds'
		matrix `D' = `D' * -1
	}
end
exit

globals used:

	macro EREGd	name of 0/1 dead variable
	macro EREGt	name of time variable
	macro EREGw	weight variable; 0 if obs. not used
			fweight:  0 or integer
			aweight:  0 or pos. real, sums to _N
			iweight:  0, or real,
