*! version 3.3.0  10oct1997   
program define xtgee
	version 5.0
        if "`*'"=="" | substr("`1'",1,1)=="," {
		di
                geerpt `*'
                exit
        }
	capture noisily Estimate `*'
	mac drop S_X_*
	exit _rc
end

program define Estimate 
	local varlist	"req ex" 
	local if	"opt"
	local in	"opt"
	local weight	"aweight pweight"
	local options	"Link(string) Family(string) Corr(string) I(string) ITER(int 100) TOL(real 1e-6) OFFset(string) Robust HASCONS noCONStant EForm FIXed(string) T(string) Scale(string) noLOg LEVel(int $S_level) SCore(string) FORCE"
	parse "`*'"

	global S_X_new
	if "$S_GEEold"=="" {
		quietly query born
		if $S_1 >= 13790 {
			global S_X_new "fixsing"
		}
	}

	GetName "`link'" "`family'" "`corr'"
	local link = "$S_1"
	local family  = "$S_2"
	local corr = "$S_3"
	local oarg = "$S_4"
	local band "$S_5"		/* default -1 */
	local fixed "$S_6"

	if "`constan'" != "" {
		local cons "nocons"
		local nocons "nocons"
	}

	

	if "`oarg'"!="" {
		cap confirm number `oarg'
		if _rc {
			unabbrev `oarg', max(1)
			local oarg "$S_1"
			local xtravar "$S_1"
		}
	}

	checkfam "`family'" "`link'"

	xt_iis `i'
	local rivar "$S_1"

	GetLag `corr' `t'
	local tvar "$S_1"

	global S_X_scp = "`scale'"

	if "`log'" == "" {
		local prel "noi di "
		global S_LOG 1
	}
	else {
		local prel "*"
	}

	if "`score'" != "" {
		confirm new var `score'
	}

        if `level'<10 | `level'>99 { local level 95 }


	ChkSyn `tol' `iter' "`hascons'" "`cons'"

	tempvar mui touse recid bb binom
	if "`offset'" != "" {
		tempvar offv
		gen double `offv' = `offset'
		local addoff "replace `mui' = `mui' + `offv'"
		local glmarg "off(`offv')"
	}
		
	mark `touse' `if' `in' 
	markout `touse' `varlist' `offv' `rivar' `tvar' `xtravar'
	local xtravar

	qui count if `touse'
	if _result(1) <= 1 {
		di in red "insufficient observations"
		exit 2001
	}

	if "`score'"!= "" {
		tempvar merge
		qui gen `merge' = _n
	}
	preserve 

	qui {
		keep if `touse'
		sort `rivar' `tvar'


		if "`tvar'"!="" { 
			tempvar tord 
			tabulate `tvar', cgen(`tord')
			if "`corr'"=="unstr" | "`corr'"=="fixed" { 
				local abst "`tord'"
				local topt "t(`tord')"
			}
			else {
				noi KeepMode `rivar' "`tvar'" "`force'"
				noi KeepMin "`corr'" `rivar' `band'
				local band $S_1
				if "`corr'"=="nonst" { 
					local abst "`tord'"
					local topt "t(`tord')"
				}
			}
			noi Checkt `rivar' `tord' `tvar'
		}
					/* Observation sample fixed */
		noi BigEnuf `rivar' `abst'
		local minni $S_1
		global S_X_maxn $S_4
		local avgni $S_3
		local maxni $S_X_maxn
		local rmaxni $S_2
		local nclust $S_5

		if "`corr'" == "fixed" {
			local g = rowsof(`fixed')
			if `maxni' != `g' {
				noi di in red /*
			*/ "correlation matrix must be `maxni'x`maxni'"
				exit 198
			}
		}
		if `nclust' == 1 & "`robust'" != "" {
			noi di in red /*
				*/ "can not specify robust with only one panel"
			exit 198
		}

		if "`weight'" != "" {
			if "`weight'" == "pweight" {
				local weight = "aweight"
				local robust "robust"
			}
			tempvar ww
			gen double `ww' `exp'
			summ `ww'
			replace `ww' = `ww'/_result(3)
			local wtex  "[aweight=`ww']"
			noi ChkWt `rivar' `ww'
		}
		else {
			tempvar ww
			gen byte `ww' = 1
		}
		local warg "wvar(`ww')"

		if "`oarg'"=="" {
			gen byte `binom' = 1
		}
		else	gen `binom' = `oarg'

		keep `varlist' `rivar' `tvar' `offv' `merge' `ww' `tord' `binom'

		if "`tvar'"=="" {
			local ivar "`rivar'"
		}
		else {
			tempvar ivar
			MakeIvar `rivar' `tvar' `tord' `maxni' -> `ivar'
			sort `ivar' `tvar'
		}

		tempvar obs
		gen float `obs' = _n
		local nobs = _N

		parse "`varlist'", parse(" ")
		global S_X_depv "`1'"
		mac shift
		global S_X_idep "`*'"

		if $S_X_con == 0 {
			local hascons 1
			if "`eform'" == "" {
				noi _rmcoll $S_X_idep `wtex', nocons
			}
			else    noi _rmcoll $S_X_idep `wtex'
			global S_X_idep "$S_1"
			_rmcoll $S_X_idep
			global S_X_HAS "$S_1"
		}
		else {
			noi _rmcoll $S_X_idep `wtex'
			global S_X_idep "$S_1"
			global S_X_HAS "$S_1"
		}
		global S_1

		local p : word count $S_X_idep
		local p = `p' + $S_X_con
		if `p' <= 0 {
			error 102
		}
		if `p' >= _N { 
			di in red "insufficient observations"
			exit 2001
		}

		global S_X_link "`link'"
		global S_X_mvar "`family'"
		global S_X_corr "`corr'"
		global S_X_ivar "`ivar'"

		sort `ivar' `tvar' `obs'

		* the following may not be necesasry 
		if `band' < 0 {
			local band = `minni'-1
		}

		if "`corr'" == "fixed" {
			local R "`fixed'"
		}
		else {
			tempname R
			mat `R' = J(`maxni',`maxni',0)
		}

		tempname b0 b1 phi alpha S1 S2 zi

		if "`family'" == "binom" {
			local xarg "`binom'"
		}

		GetIval "`hascons'" "`nocons'" "`wtex'" /*
			*/ "`xarg'" "`oarg'" -> `b1' "`glmarg'"
		local sna : colnames(`b1')
	
		local XXn : word count `sna'
		if `XXn' != `p' {
			noi di in red "Unable to identify sample"
			exit 198
		}

		local iterate 1
		local diff 1000

		tempvar ei t cc lagw

		sort `ivar' `tvar' `obs'
		while `iterate' < `iter' & `diff' > `tol' {

			mat `b0' = `b1'
			scalar `phi' = 0.0

			* switch(link) page 4

			cap drop `mui' 
			mat score double `mui' = `b1'
			`addoff' /* replace `mui' = `mui' + `offv' */
			plink "`link'" `mui' `binom'

			* switch (var_mean_rel) page 4

			cap drop `ei'	
			gen double `ei' = $S_X_depv - `mui'
			elink "`family'" `mui' `ei' `binom'

			cap drop `cc'
			gen double `cc' = `ei'*`ei'
			cap drop `t'
if "$S_X_new"=="" {
			by $S_X_ivar: gen double `t' = sum(`cc')/_N
			by $S_X_ivar: replace `t' = `t'[_N]
			by $S_X_ivar: replace `t' = . if _n!=1
			summ `t'
			scalar `phi' = _result(3)*_result(1)
}
else {
/* Use Liang Zeger 1986 moment estimators instead of Karim estimators */
			summ `cc'
/* N-p */
			scalar `phi' = (`nobs' -`p') / _result(18)
			by $S_X_ivar : gen double `t' = .5*_N*(_N-1) if _n==_N
			summ `t'
			tempname cF
			scalar `cF' = _result(18) - `p' /* N-p */
/* End of new */
}

			cap drop `lagw'
			local bw1 = `band'+1
			by $S_X_ivar : gen double `lagw' = _N/(_N-_n+1) /*
			*/ if _n <= `bw1'

			_GEEUC `ei', a(`alpha') ty(`corr') n(`maxni') /*
				*/ b(`band') l(`lagw') `topt' by($S_X_ivar) /*
				*/ $S_X_new
			if "`corr'" == "exchan" {
if "$S_X_new"=="" {
				scalar `alpha' = `alpha'/`phi'
}
else				scalar `alpha' = `alpha'*`phi'/`cF'

				if ((`alpha'<-1) | (`alpha'>1)) {
					noi di in red "estimates diverging"
					exit 430
				}
			}
			else if "`corr'" != "fixed" & "`corr'" != "indep" {
if "$S_X_new"=="" {
				local ophi = 1.0/`phi'
				mat `alpha' = `ophi' * `alpha'
}
else {
				if "`corr'"=="statm" | "`corr'"=="arm" {
					local kk = colsof(`alpha')
					tempname ttt
					local i 1
					while `i' <= `kk' {
						scalar `ttt' = `phi' / /*
					*/ (`nobs'+`nclust'-`nclust'*`i'-`p')
						mat `alpha'[1,`i'] = /*
					*/ `alpha'[1,`i'] * `ttt'
						local i = `i'+1
					}
				}
				else if "`corr'" == "nonst" {
					tempname ttt
					scalar `ttt' = `phi' / (`nclust') 
					mat `alpha' = `ttt' * `alpha'
				}
				else {
					/* unstructured */
					tempname ttt
					scalar `ttt' = `phi' / (`nclust') 
					mat `alpha' = `ttt' * `alpha'
				}
}
			}

if "$S_X_new"=="" {
			scalar `phi' = `phi'/`nclust'
}

			* switch (corstruct) page 6

			if "`corr'" == "arm" {
				rarm `R' `maxni' `alpha' `bw1'
			}
			else _GEERC , c(`corr') r(`R') n(`maxni') /*
			*/ a(`alpha') b(`bw1')

			* Bottom of page 6

			cap drop `mui' 	
			mat score double `mui' = `b1'
			`addoff' /* replace `mui' = `mui' + `offv' */

			_GEEBT $S_X_idep, mui(`mui') N(`binom') by(`ivar') /*
			*/ `warg' xy(`S1') xx(`S2') R(`R') /*
			*/ b1(`b1') depv($S_X_depv) n(`maxni') `topt'

			* get S1 and S2 page 8
			mat `b1' = syminv(`S2')
			mat `b1' = `b1'*`S1'
			mat `b1' = `b1''

			mat colnames `b1' = `sna'

			* now get max diff between oldbeta and newbeta
			local diff = mreldif(`b1', `b0')
			`prel' in gr "Iteration " `iterate' /*
			*/ ": tolerance = " in ye `diff'
			local iterate = `iterate'+1
		}

		if `iterate' >= `iter' {
			local finalrc 430
		}
		else	local finalrc 0

		* Page 9 loop
		cap drop `zi'

		scalar `phi' = 0.0
		cap drop `mui' 	
		mat score double `mui' = `b1' 
		`addoff' /* replace `mui' = `mui' + `offv' */

		if "`score'" != "" {
			qui gen double `score' = .
			local sarg "score(`score')"
		}

		_GEEBT $S_X_idep, mui(`mui') N(`binom') by(`ivar') /*
		*/ `warg' phi(`phi') `sarg' `robust' xy(`S1') xx(`S2') /*
		*/ R(`R') b1(`b1') depv($S_X_depv) n(`maxni') `topt'

if "$S_X_new"=="" {
			scalar `phi' = `phi'/`nclust'
}
else			scalar `phi' = `avgni'*`phi' / (`nobs' -`p') /* N-p */

		global S_E_dof = `nobs'-`p'
		local mydof $S_E_dof
		global S_E_scp "$S_X_scp"

		FixScale $S_X_depv `mui' `binom' "`wtex'"
		if "$S_X_fix" != "" {
			scalar `phi' = $S_1
		}

		mat `S2' = syminv(`S2')

		tempname nse rse

		mat `nse' = `phi'*`S2'
		mat `rse' = `S2'*`S1'
		mat `rse' = `rse'*`S2'
		mat drop `S1'
		mat drop `S2'
	}
	mat colnames `nse' = `sna'
	mat rownames `nse' = `sna'
	mat colnames `rse' = `sna'
	mat rownames `rse' = `sna'

	global S_X_9 = "$S_E_dis"
	global S_X_A = "$S_E_scp"
	if "`robust'" != "" {
		local df = `nclust'-1
		local factor = (`nclust')/(`df')
		if "`family'"=="gauss" {
			local factor = `factor' * (`nobs'-1)/(`nobs'-`p')
		}
		mat `rse' = `rse' * `factor'
		mat post `b1' `rse', depname($S_X_depv) obs(`nobs') 
		global S_E_vce "Robust"
	}
	else {
		mat post `b1' `nse', depname($S_X_depv) obs(`nobs') 
	}


	if "`corr'" == "arm" {
		rarm `R' `maxni' `alpha' `bw1'
	}
	else _GEERC , c(`corr') r(`R') n(`maxni') a(`alpha') b(`bw1')
	mat S_E_R = `R'


	capture qui test $S_X_HAS, min
	if _rc == 0 {
		global S_E_chi2 = _result(6)
		global S_E_chdf = _result(3)
		global S_E_prob = chiprob($S_E_chdf,$S_E_chi2)
	}
	else {
		global S_E_chi2 .
		global S_E_chdf 0
		global S_E_prob .
	}


	if "$S_LOG" != "" {
		noi di 
	}

	/* Save results */

	SaveMac `mydof' `nobs' `nclust' `rmaxni' `minni' `avgni' `tol' `diff' /*
		*/ `phi' `family' `link' `corr' "`tvar'" "`band'" `level'  
	global S_E_ivar "`rivar'"
	fixwords
	if "`robust'" != "" {
		global S_E_cvn "`rivar'"
	}
	global S_E_cmd = "xtgee"
	global S_E_rc 0
	geerpt , `eform'
	global S_E_rc `finalrc'			/* sic */
	global S_LOG



	if "`score'" != "" {
		qui replace `score' = `score'/sqrt(`phi')
		keep `merge' `score'
		sort `merge'
		tempfile tmpf
		qui save `tmpf'
		restore
		sort `merge'
		cap merge `merge' using `tmpf'
		if _rc {
			if _rc==1 { exit 1 }
			noi di in red "Unable to generate score `score'"
			exit 198
		}
		drop _merge 
	}
	error `finalrc'
end

program define geerpt
	global S_X_maxn
	global S_X_corr
	global S_X_mvar
	global S_X_link
	global S_X_idep
	global S_X_depv
	global S_X_con
	global S_X_9
	local options "LEvel(int $S_level) EForm"
	parse "`*'"
	if "$S_E_cmd"!="xtgee" { error 301 }
        if `level'<10 | `level'>99 {
                di in red "level() must be between 10 and 99"
                exit 198
        }
	global S_level  `level'

	global S_E_ef
	if "`eform'" != "" {
		if "$S_E_fam"=="Poisson" & "$S_E_lnk" != "probit" & /*
		*/ "`link'" != "logit" {
			global S_E_ef "eform(IRR)"
		}
		else if "$S_E_lnk" == "probit" & "$S_E_fam" != "Poisson" {
			global S_E_ef "eform(ExpB)"
		}
		else if "$S_E_lnk" == "logit" & "$S_E_fam" != "Poisson" {
			global S_E_ef "eform(Odds Ratio)"
		}
		else {
			global S_E_ef "eform(e^coef)"
		}
	}

	local q "_col(68)"
	local l = 71 + 8 - length("$S_E_ivar")
	noi di in green "General estimating equation for panel data"  /*
	*/ in gr _col(51) "Number of obs" `q' "=" in ye _col(70) %9.0g $S_E_nobs

	if "$S_E_tvar"!="" {
		local skip = max(43-length("$S_E_ivar $S_E_tvar"),1)

		di in gr "Group and time vars:" in ye _col(`skip') /*
		*/ "$S_E_ivar $S_E_tvar" /*
		*/ in gr _col(51) "Number of groups" `q' "=" /*
		*/ in ye _col(70) %9.0g $S_E_ncl
	}
	else {
		local skip = max(43-length("$S_E_ivar"),1)
		di in gr "Group variable:" in ye _col(`skip')  /*
		*/ "$S_E_ivar" /*
		*/ in gr _col(51) "Number of groups" `q' "=" /*
		*/ in ye _col(70) %9.0g $S_E_ncl
	}

	local skip = max(43 - length("$S_E_lnk"),1)
	noi di in green "Link:" in ye _col(`skip') "$S_E_lnk" /*
	*/ in gr _col(51) "Obs/group, min" `q' "=" in ye _col(70) /*
	*/ %9.0g $S_E_ntmn   

	local skip = max(43 - length("$S_E_fam"),1)
	noi di in green "Family:" in ye _col(`skip') "$S_E_fam" /*
	*/ in gr _col(62) "avg" `q' "=" in ye _col(70) /*
	*/ %9.2f $S_E_ntav   

	local skip = max(43 - length("$S_E_cor"),1)
	noi di in green "Correlation:" in ye _col(`skip') /*
	*/ "$S_E_cor" in gr _col(62) "max" `q' "=" /*
	*/ in ye _col(70) %9.0g $S_E_ntmx   

	if $S_E_chi2>999999 {
		local cfmt "%9.0g"
	}
	else	local cfmt "%9.2f"

	noi di in green  /*
	*/ in gr _col(51) "chi2(" $S_E_chdf ")" `q' "=" /*
	*/ in ye _col(70) `cfmt' $S_E_chi2

	if $S_E_P1>999999 {
		local cfmt "%10.0g"
	}
	else	local cfmt "%10.2f"
	noi di in green /*
	*/ "Scale parameter: "  _col(34) in ye %9.0g $S_E_phi /*
	*/ in gr _col(51) "Prob > chi2" `q' "=" /*
	*/ in ye _col(73) %6.4f $S_E_prob

	if $S_E_D1>999999 { 
		local cfmt "%10.0g"
	}
	else	local cfmt "%10.2f"


	if "$S_E_D1" != "" {
		noi di in gr "Pearson chi2(" $S_E_rdf "):" /*
		*/ in ye _col(33) `cfmt' $S_E_P1 /*
		*/ in gr _col(51) "Deviance" `q' "=" in ye _col(69) /*
		*/ `cfmt'  $S_E_D1

		noi di in gr "Dispersion (Pearson):" in ye _col(34) /*
		*/ %9.0g $S_E_P2 /*
		*/ in gr _col(51) "Dispersion" `q' "=" in ye _col(70) /*
		*/ %9.0g $S_E_D2
	}


	di
	mat mlout, level($S_level) $S_E_ef
	if "$S_E_dis" == "$S_E_phi" {
		cap confirm number $S_E_scp
		local j = _rc
		if "$S_E_scp" == "dev" {
			local mm "deviance based dispersion"
		}
		else if "$S_E_scp" == "x2" {
			local mm "Pearson X2-based dispersion"
		}
		else {
			local mm "$S_E_scp"
		}
		if /*
*/ (("$S_E_fam"=="Gaussian" | "$S_E_fam"=="gamma") & "$S_E_scp"!="x2") | /*
*/ (("$S_E_fam"=="Poisson" | "$S_E_fam"=="binomial") & "$S_E_scp"!="1") {
			noi di in gr  /*
			*/ "(Standard errors scaled using square root of `mm')"
		}
	}
	error $S_E_rc
end


program define plink
	local type "`1'"
	local m "`2'"
	local N "`3'"

	if "`type'" == "log" {
		replace `m' = exp(`m')
	}
	else if "`type'" == "logit" {
		replace `m' = (`N'*exp(`m'))/(1+exp(`m'))
		if "$S_X_mvar" == "binom" {
			tempvar fitted
			gen `fitted' = `m'/`N'
			summ `fitted'
			if _result(6) >= .9999 {
				replace `m' = (`m'/`N'*.9999)*`N'
			}
		}
	}
	else if "`type'" == "recip" {
		replace `m' = 1/`m'
	}
	else if "`type'" == "probit" {
		replace `m' = `N'*normprob(`m')
		if "$S_X_mvar" == "binom" {
			tempvar fitted
			gen `fitted' = `m'/`N'
			summ `fitted'
			if _result(6) >= .9999 {
				replace `m' = (`m'/`N'*.9999)*`N'
			}
		}
	}
end


program define elink
	local type "`1'"
	local m "`2'"
	local e "`3'"
	local N "`4'"

	if "`type'" == "poiss" {
		replace `e' = `e'/sqrt(`m')
	}
	else if "`type'" == "binom" {
		replace `e' = `e'/sqrt(`m'*(1-`m'/`N'))
	}
	else if "`type'" == "gamma" {
		replace `e' = `e'/`m'
	}
end


program define rarm
	local R "`1'"
	local n `2'
	local a "`3'"
	local b `4'

	mat `a'[1,1] = 1
	tempname tmp wt al
	local b2 = `b'-1
	mat `tmp' = J(1,`n',0)
	local i 1
	while `i' <= `n' {
		mat `tmp'[1,`i'] = `a'[1,`i']
		local i = `i'+1
	}
	mat `wt' = J(`b2',`b2',0)
	local i 1
	while `i' <= `b2' {
		local j = `i'
		while `j' <= `b2' {
			local k = `j'-`i'+1
			mat `wt'[`j',`i'] = `tmp'[1,`k']
			mat `wt'[`i',`j'] = `tmp'[1,`k']
			local j = `j'+1
		}
		local i = `i'+1
	}

	mat `wt' = syminv(`wt')
	mat `al' = J(1,`b2',0) 
	local i 1
	while `i' <= `b2' {
		local j = `i'+1
		mat `al'[1,`i'] = `a'[1,`j']
		local i = `i'+1
	}
	mat `al' = `al'*`wt'
	mat drop `wt'

	tempname scnm
	local i = `b'
	while `i' <= `n' {
		scalar `scnm' = 0
		local j 1
		while `j' <= `b2' {
			local k = `i'-`j'
			scalar `scnm' = `scnm' + `al'[1,`j']*`tmp'[1,`k']
			local j = `j'+1
		}
		mat `tmp'[1,`i'] = `scnm'
		local i = `i'+1
	}
	_GEERC , c(arm) r(`R') n(`n') a(`tmp') b(`b')
end


program define checkcm
	local cmat "`1'"

	cap local nrow = rowsof(`cmat')
	if _rc {
		noi di in red "`cmat' not a matrix"
		exit 198
	}

	local ncol = colsof(`cmat')

	if `ncol' != `nrow' {
		noi di in red "correlation matrix not square"
		exit 198
	}

	local i 1
	while `i' < `nrow' {
		if `cmat'[`i',`i'] != 1.0 {
			noi di in red "`cmat' not a correlation matrix"
			exit 198
		}
		local j = `i' + 1
		while `j' <= `nrow' {
			if `cmat'[`i',`j'] != `cmat'[`j',`i'] {
				noi di in red "`cmat' not symmetric"
				exit 198
			}
			if `cmat'[`i',`j'] > 1 | `cmat'[`i',`j'] < -1 {
				noi di in red "`cmat' not a correlation matrix"
				exit 198
			}
			local j = `j'+1
		}
		local i = `i'+1
	}
	if `cmat'[`i',`i'] != 1.0 {
		noi di in red "`cmat' not a correlation matrix"
		exit 198
	}
end

program define checkfam /* family link */
	local family "`1'"
	local link "`2'"
	
	local flag 0 

	if "`family'"=="gauss" {
		if "`link'"!="ident" & "`link'"!="log"  & "`link'"!="recip" {
			local flag 1
		}
	}

	else if "`family'"=="poiss" {
		if "`link'"!="ident"&"`link'"!="log" & "`link'"!="recip" {
			local flag 1
		}
	}

	else if "`family'" == "gamma" {
		if "`link'"!="ident" & "`link'"!="log" & "`link'" != "recip" {
			local flag 1
		}
	}

	if `flag' == 1 {
		noi di in red "unsupported family-link combination"
		exit 198
	}
end

program define GetName
	local link "`1'"
	local fam "`2'"
	local corr "`3'"

	global S_1	/* link		*/
	global S_2	/* family	*/
	global S_3	/* corr		*/
	global S_4	/* family arg	*/
	global S_5 -1	/* corr lag	*/
	global S_6	/* corr mat	*/

	local l = length("`link'")
	local f = lower(trim("`link'"))

	if "`f'" == substr("identity",1,max(`l',2)) { global S_1 "ident" }
	else if "`f'" == substr("log",1,max(`l',3))      { global S_1 "log"   }
	else if "`f'" == substr("logit",1,max(`l',4))    { global S_1 "logit" }
	else if "`f'" == substr("probit",1,max(`l',3))   { global S_1 "probit"}
	else if "`f'"==substr("reciprocal",1,max(`l',3)) { global S_1 "recip" }
	else if "`f'" != "" {
		noi di in red "unknown link() `link'"
		exit 198
	}

	local l = length("`fam'")
	local f = lower(trim("`fam'"))
	local f : word 1 of `f'
	local l = length("`f'")

	if "`f'" == substr("gaussian",1,max(`l',3)) { global S_2 "gauss" }
	else if "`f'" == substr("normal",1,max(`l',3))   { global S_2 "gauss" }
	else if "`f'" == substr("poisson",1,max(`l',3))  { global S_2 "poiss" }
	else if "`f'" == substr("binomial",1,max(`l',3)) { global S_2 "binom" }
	else if "`f'" == substr("gamma",1,max(`l',3))    { global S_2 "gamma" }
	else if "`f'" != "" {
		noi di in red "unknown family() `fam'"
		exit 198
	}

	global S_4
	if "$S_2" == "binom" {
		parse "`fam'", parse(" ")
		global S_4 "`2'"
	}

	GetCorr "`corr'" /* sets S_3, S_5, S_6 */

	if "$S_3" == "" {
		global S_3 "exchan"
	}

	if "$S_2" == "" {
		global S_2 "gauss"
	}

	if "$S_1" == "" {
		if "$S_2" == "gauss" { global S_1 "ident" }
		if "$S_2" == "poiss" { global S_1 "log"   }
		if "$S_2" == "binom" { global S_1 "logit" }
		if "$S_2" == "gamma" { global S_1 "recip" }
	}

end

program define GetCorr /* correlation <#> */
/*
	We parse
		<correlation>
		<correlation>[ ]#
		<correlation> <matname>
*/
	ReTok `*'
	local f = lower(trim("$S_3"))
	local l = length("`f'")
	local rest "$S_5"

	global S_3	/* corr */
	global S_5 -1	/* lag */
	global S_6	/* matname */

	if "`f'"=="" { exit }

	if "`f'" == substr("independent",1,max(`l',3))	     { 
		global S_3 "indep" 
		NoLag `f' `rest'
	}
	else if "`f'" == substr("arm",1,max(`l',2))   { 
		global S_3 "arm" 
		SetLag `f' `rest'
	}
	else if "`f'" == substr("exchangeable",1,max(`l',3))   { 
		global S_3 "exchan" 
		NoLag `f' `rest'
	}
	else if "`f'" == substr("statm",1,max(`l',3))   { 
		global S_3 "statm" 
		SetLag `f' `rest'
	}
	else if "`f'" == substr("stationary",1,max(`l',3))   { 
		global S_3 "statm" 
		SetLag `f' `rest'
	}
	else if "`f'" == substr("nonstationary",1,max(`l',3))   { 
		global S_3 "nonst" 
		SetLag `f' `rest'
	}
	else if "`f'" == substr("unstructured",1,max(`l',3))   { 
		global S_3 "unstr" 
		NoLag `f' `rest'
	}
	else if "`f'" == substr("fixed",1,max(`l',3))   { 
		global S_3 "fixed" 
		SetMat `f' `rest'
		checkcm $S_6
	}
	else if "`f'" != "" {
		noi di in red "unknown corr structure `corr'"
		exit 198
	}
end

program define ReTok 
	if "`2'"=="" {
		local c = substr("`1'",length("`1'"),1)
		while "`c'">="0" & "`c'"<="9" {
			local 1 = substr("`1'",1,length("`1'")-1)
			local 2 "`c'`2'"
			local c = substr("`1'",length("`1'"),1)
		}
	}
	global S_3 "`1'"
	mac shift 
	global S_5 "`*'"
end

program define NoLag
	if "`2'"!="" {
		BadCorr `*'
	}
end

program define BadCorr
	di in red "corr(`*') invalid"
	exit 198
end

program define SetLag
	if "`3'" != "" {
		BadCorr `*'
	}
	if "`2'"=="" {
		global S_5 1
		exit 
	}
	cap confirm integer number `2'
	if _rc {
		BadCorr `*'
	}
	if `2'<1 {
		BadCorr `*'
	}
	global S_5 `2'
end

program define SetMat
	if "`3'"!="" {
		BadCorr `*'
	}
	cap mat list `2'
	if _rc {
		if _rc==111 { 
			di in red "matrix `3' not found"
			exit 111
		}
		BadCorr `*'
	}
	global S_6 `2'
end

program define FixScale
	local y "`1'"
	local mu "`2'"
	local m "`3'"
	local wtxp "`4'"

	global S_X_fix
	if "$S_E_scp" == "" {
		global S_X_fix 1
		if "$S_X_mvar" == "gauss" | "$S_X_mvar" == "gamma" {
			global S_E_scp "x2"
		}
		else {
			global S_E_scp 1 
		}
	}

	tempvar dj
	if "$S_X_mvar" == "gauss" {
		if "$S_E_scp" == "dev" {
			gen double `dj' = (`y'-`mu')^2			
			global S_X_fix 1
		}
		else if "$S_E_scp" == "x2" {
			gen double `dj' = (`y'-`mu')
		}
	}
	if "$S_X_mvar" == "poiss" {
		if "$S_E_scp" == "dev" {
			gen double `dj' = 2*`mu'			
			replace `dj' = 2*(`y'*log(`y'/`mu')-(`y'-`mu')) if `y'
			global S_X_fix 1
		}
		else if "$S_E_scp" == "x2" {
			gen double `dj' = (`y'-`mu')/sqrt(`mu')
			global S_X_fix 1
		}
	}
	if "$S_X_mvar" == "gamma" {
		if "$S_E_scp" == "dev" {
			gen double `dj' = -2*(log(`y'/`mu')-(`y'-`mu')/`mu')
			global S_X_fix 1
		}
		else if "$S_E_scp" == "x2" {
			gen double `dj' = (`y'-`mu')/sqrt((`mu')^2)
		}
	}
	if "$S_X_mvar" == "binom" {
		if "$S_E_scp" == "dev" {
			gen double `dj' = 2*`y'*log(`y'/`mu')+ /*
			*/ 2*(`m'-`y')*log((`m'-`y')/(`m'-`mu')) 
			replace `dj' = 2*`m'*log(`m'/(`m'-`mu')) if `y'==0
			replace `dj' = 2*`y'*log(`y'/`mu') if `y'==`m'
			global S_X_fix 1
		}
		else if "$S_E_scp" == "x2" {
			gen double `dj' = (`y'-`mu')/sqrt(`mu'*(1-`mu'/`m'))
			global S_X_fix 1
		}
	}
	if "$S_E_scp" == "x2" {
		replace `dj' = (`dj')^2
	}
	
	if "$S_E_scp" != "phi" {
		cap confirm number $S_E_scp
		if _rc {
			summ `dj' `wtxp'
			global S_1 = _result(1)*_result(3)/$S_E_dof
			global S_E_dis = $S_1
		}
		else {
			global S_1 = $S_E_scp
		}
		global S_X_fix 1
	}
        else    global S_1

	if "$S_X_mvar" == "gauss" {
		cap drop `dj'
		gen double `dj' = (`y'-`mu')^2			
		summ `dj' `wtexp'
		global S_X_D1 = _result(1)*_result(3)
		global S_X_D2 = _result(1)*_result(3)/$S_E_dof
		cap drop `dj'
		gen double `dj' = (`y'-`mu')
		replace `dj' = (`dj')^2
		summ `dj' `wtexp'
		global S_X_P1 = _result(1)*_result(3)
		global S_X_P2 = _result(1)*_result(3)/$S_E_dof
	}
	else if "$S_X_mvar" == "poiss" {
		cap drop `dj'
		gen double `dj' = 2*`mu'			
		replace `dj' = 2*(`y'*log(`y'/`mu')-(`y'-`mu')) if `y'
		summ `dj' `wtexp'
		global S_X_D1 = _result(1)*_result(3)
		global S_X_D2 = _result(1)*_result(3)/$S_E_dof
		cap drop `dj'
		gen double `dj' = (`y'-`mu')/sqrt(`mu')
		replace `dj' = (`dj')^2
		summ `dj' `wtexp'
		global S_X_P1 = _result(1)*_result(3)
		global S_X_P2 = _result(1)*_result(3)/$S_E_dof
	}
	if "$S_X_mvar" == "gamma" {
		cap drop `dj'
		gen double `dj' = -2*(log(`y'/`mu')-(`y'-`mu')/`mu')
		summ `dj' `wtexp'
		global S_X_D1 = _result(1)*_result(3)
		global S_X_D2 = _result(1)*_result(3)/$S_E_dof
		cap drop `dj'
		gen double `dj' = (`y'-`mu')/sqrt((`mu')^2) 
		replace `dj' = (`dj')^2
		summ `dj' `wtexp'
		global S_X_P1 = _result(1)*_result(3)
		global S_X_P2 = _result(1)*_result(3)/$S_E_dof
	}
	else if "$S_X_mvar" == "binom" {
		cap drop `dj'
		gen double `dj' = 2*`y'*log(`y'/`mu')+ /*
		*/ 2*(`m'-`y')*log((`m'-`y')/(`m'-`mu')) 
		replace `dj' = 2*`m'*log(`m'/(`m'-`mu')) if `y'==0
		replace `dj' = 2*`y'*log(`y'/`mu') if `y'==`m'
		summ `dj' `wtexp'
		global S_X_D1 = _result(1)*_result(3)
		global S_X_D2 = _result(1)*_result(3)/$S_E_dof
		cap drop `dj'
		gen double `dj' = (`y'-`mu')/sqrt(`mu'*(1-`mu'/`m'))
		replace `dj' = (`dj')^2
		summ `dj' `wtexp'
		global S_X_P1 = _result(1)*_result(3)
		global S_X_P2 = _result(1)*_result(3)/$S_E_dof
	}
end

program define ChkWt /* ivar wv */
	local ivar "`1'"
	local v "`2'"
	cap by `ivar': assert `v'==`v'[_n-1] if _n>1
	if _rc {
		noi di in red "weight must be constant within `ivar'"
		exit 199
	}
end

program define ChkSyn
	local tol = `1'
	local iter = `2'
	local hascons "`3'"
	local cons "`4'"

	if `tol' <= 0 {
		noi di in red "tolerance must be positive"
		exit 198
	}
	if `iter' < 1 {
		noi di in red "iter must be positive"
		exit 198
	}

	if "$S_X_scp" != "" {
		cap confirm number $S_X_scp
		if _rc {
			if "$S_X_scp" != "dev" & "$S_X_scp" != "x2" /*
			*/ & "$S_X_scp" != "phi" {
				noi di in red /*
			*/ "unknown scale option"
				exit 198
			}
		}
	}

	if "`hascons'" != "" & "`cons'" != "" {
		noi di in red "Can not specify both hascons and nocons"
		exit 198
	}

	if "`hascons'" != "" | "`cons'" != "" {
		global S_X_con 0
	}
	else    global S_X_con 1

end

program define fixwords
	if "$S_E_fam" == "gauss" { global S_E_fam "Gaussian" }
	if "$S_E_fam" == "binom" { global S_E_fam "binomial" }
	if "$S_E_fam" == "poiss" { global S_E_fam "Poisson" }
	if "$S_E_fam" == "gamma" { global S_E_fam "gamma" }

	if "$S_E_lnk" == "ident"  { global S_E_lnk "identity" }
	if "$S_E_lnk" == "log"    { global S_E_lnk "log" }
	if "$S_E_lnk" == "logit"  { global S_E_lnk "logit" }
	if "$S_E_lnk" == "recip"  { global S_E_lnk "reciprocal" }
	if "$S_E_lnk" == "probit" { global S_E_lnk "probit" }

	if "$S_E_cor" == "indep"   { global S_E_cor "independent" }
	if "$S_E_cor" == "exchan"  { global S_E_cor "exchangeable" }
	if "$S_E_cor" == "statm"   { global S_E_cor "stationary($S_E_bw)" }
	if "$S_E_cor" == "arm"     { global S_E_cor "AR($S_E_bw)" }
	if "$S_E_cor" == "nonstat" { global S_E_cor "nonstationary($S_E_bw)" }
	if "$S_E_cor" == "unstr"   { global S_E_cor "unstructured" }
	if "$S_E_cor" == "fixed"   { global S_E_cor "fixed (specified)" }
end

program define KeepMode /* ivar tvar [force] */
	local ivar "`1'"
	local tvar "`2'"
	local force "`3'"

	if "`force'"!="" { exit }
	tempvar bb
	qui {
		by `ivar': gen float `bb' = `tvar'-`tvar'[_n-1]
		by `ivar': replace `bb' = `bb'[2] if _n==1
		qui summ `bb'
		cap assert `bb' == _result(5) | `bb'==.
		if _rc==0 { exit }
		
		tempname mesh
		tempvar freq bad
		sort `bb' 
		by `bb': gen `freq'=_N if _n==_N
		summ `freq'
		summ `bb' if `freq'==_result(6) 
		scalar `mesh' = _result(5) 
		sort `ivar' `tvar'
		drop `freq'
		by `ivar': gen `bad' = cond(_n==1,0,`bb'!=`mesh')
		by `ivar': replace `bad' = cond(_n==_N,sum(`bad')!=0,0)
		summ `bad', mean
	}
	di in gr _n /* 
	*/ "note:  observations not equally spaced" _n /* 
	*/ _col(8) "modal spacing is delta `tvar' = " `mesh' _n /* 
	*/ _col(8) _result(18) " groups omitted from estimation" 
	qui by `ivar': drop if `bad'[_N]
	if _N==0 { 
		di in red "no observations"
		exit 2000
	}
end

program define TooFewMg /* band */
	di in gr "note:  some groups have fewer than " /*
	*/ `1'+1 " observations" _n  _col(8) /* 
	*/ "not possible to estimate correlations for those groups" _n /* 
	*/ _col(8) _result(18) " groups omitted from estimation" _n
end


program define GetLag
	local corr "`1'"
	local t "`2'"

        if "`corr'"=="statm" | "`corr'"=="nonst" | "`corr'"=="arm" /*
		*/ | "`corr'"=="unstr" | "`corr'"=="fixed" {
                xt_tis `t'
        }
	else { global S_1 }
end

program define SaveMac
	global S_E_rdf `1'
	global S_E_nobs `2'
	global S_E_ncl `3'
	global S_E_ntmx `4'
	global S_E_ntmn `5'
	global S_E_ntav `6'
	global S_E_tol `7'
	global S_E_dif `8'
	global S_E_phi = `9'
	global S_E_fam = trim("`10'")
	global S_E_lnk = trim("`11'")
	global S_E_cor = trim("`12'")
	global S_E_tvar = trim("`13'")
	global S_E_depv = trim("$S_X_depv")
	global S_E_vl "$S_X_depv $S_X_idep"
	global S_X_ivar
	if "`14'" != "" {
		global S_E_bw = `14'
	}
	else    global S_E_bw
	global S_level = `15'
	global S_E_dis "$S_X_9"
	global S_E_scp "$S_X_A"
	global S_E_D1 "$S_X_D1"
	global S_E_D2 "$S_X_D2"
	global S_E_P1 "$S_X_P1"
	global S_E_P2 "$S_X_P2"
end


program define BigEnuf /* ivar [tord] */
	local ivar "`1'"
	local tord "`2'"
	tempvar bb
	tempname chkme
	quietly {
		by `ivar': gen float `bb' = _N if _n==_N
		summ `bb' 
		global S_1 = _result(5)
		global S_2 = _result(6) 
		global S_3 = _result(3) 
		global S_4 = _result(6)
		global S_5 = _result(1)

		if "`tord'"!="" {
			drop `bb'
			by `ivar': gen float `bb' = `tord' if _n==_N
			summ `bb' 
			global S_4 = _result(6)
		}
		cap mat `chkme' = I($S_4)
		if _rc {
			noi di in red /*
			*/ "matsize too small -- must be at least " $S_4+1
			exit 908
		}
		mat drop `chkme'
	}
end


program define KeepMin /* corr ivar band */
	local corr "`1'"
	local ivar "`2'"
	local band "`3'"

	if ("`corr'"!="statm" & "`corr'"!="arm" & "`corr'"!="nonst" ) {
		global S_1 `band'
		exit
	}
	if `band' < 0 {
		local band 1
	}
	tempvar bb c
	quietly {
		by `ivar': gen int `c' = _N
		summ `c'
		if `band'<_result(5) {
			global S_1 `band'
			exit
		}
		by `ivar' : gen byte `bb' = 1 if `c'<=`band' & _n==1
		summ `bb'
		noi TooFewMg `band'
		drop `bb'
		keep if `c' > `band'
	}
	global S_1 `band'
end


program define GetIval /* hascons nocons wexp xarg oarg -> b1 */
	local hascons "`1'"
	local nocons "`2'"
	local wtex "`3'"
	local xarg "`4'"
	local oarg "`5'"
	local b1 "`7'"
	local offarg "`8'"

	
	if "`offarg'" != "" {
		local options "OFFset(string)"
		parse ",`offarg'"
		local moff "-`offset'"
	}

	local link "$S_X_link"
	local family "$S_X_mvar"

	if "`hascons'" == "" & "`nocons'" == "" {
		local glink = "`link'"
		if "`family'" == "gauss" & "`link'" == "ident" {
			tempvar jwh
			gen double `jwh' = $S_X_depv `moff'
			reg `jwh' $S_X_idep `wtex'
			*reg $S_X_depv $S_X_idep `wtex'
		}
		else if "`family'" == "binom" & "`link'" == "probit" /*
		*/ & "`oarg'" == "" & "`offarg'"=="" {
			cap probit $S_X_depv $S_X_idep `wtex', nolog nocoef
		}
		else if "`family'" == "binom" & "`link'" == "logit" /*
		*/ & "`oarg'" == "" & "`offarg'"=="" {
			cap logit $S_X_depv $S_X_idep `wtex'
		}
		else {
			if "`glink'" == "recip" {
				local glink = "power -1"
			}
			cap glm $S_X_depv $S_X_idep `wtex', /*
			*/ fam(`family' `xarg') link(`glink') `offarg'
		}
		if _rc & _rc!=430 {
			if _rc==1 { exit 1 }
			tempvar jwh
			gen double `jwh' = $S_X_depv `moff'
			reg `jwh' $S_X_idep 
			*reg $S_X_depv $S_X_idep 
		}
		LoadMat `b1'
		exit
	}

	if "`hascons'" != "" & "`cons'" == "" {
		local glink = "`link'"
		if "`glink'" == "recip" {
			local glink = "power -1"
		}
		local cf 0
		cap glm $S_X_depv $S_X_idep `wtex', /*
		*/ fam(`family' `xarg') link(`glink') nocons `offarg'
		if _rc & _rc!=430 {
			if _rc==1 { exit 1 }
			tempvar jwh
			gen double `jwh' = $S_X_depv `moff'
			reg `jwh' $S_X_idep, nocons
			*reg $S_X_depv $S_X_idep, hascons
			local cf 1
		}
		LoadMat `b1'
		local nc = colsof(`b1') - `cf'
		mat `b1' = `b1'[1,1..`nc']
		exit
	}

	local glink = "`link'"
	if "`glink'" == "recip" {
		local glink = "power -1"
	}
	cap glm $S_X_depv $S_X_idep `wtex', /*
	*/ fam(`family' `xarg') link(`glink') nocons `offarg'
	if _rc & _rc!=430 {
		if _rc==1 { exit 1 }
		tempvar jwh
		gen double `jwh' = $S_X_depv `moff'
		reg `jwh' $S_X_idep, nocons
		*reg $S_X_depv $S_X_idep, nocons
	}
	LoadMat `b1'
end

program define LoadMat /* matname */
	capture mat `1' = get(_b) 
	if _rc==0 { exit }
	if _rc != 301 { error _rc }
	di in red "family/link inapproprite for this data"
	exit 2001
end

program define MakeIvar /* rivar tvar tord maxni -> ivar */
	local rivar "`1'"
	local tvar "`2'"
	local tord "`3'"
	local maxni `4'
	local ivar `6'

	tempvar pi ti 
	tempname p 
	scalar `p' = cond(`maxni'<=50, 2, 2^(50/(`maxni'+1)))
	by `rivar': gen double `pi' = sum((`p')^`tord')
	by `rivar': replace `pi' = `pi'[_N]
	by `rivar': gen int `ti' = _N 
	sort `ti' `pi' `rivar' 
	by `ti' `pi' `rivar': gen long `ivar' = 1 if _n==1
	replace `ivar' = sum(`ivar')
end

program define Checkt
	local ivar "`1'"
	local tvar "`2'"
	local rtvar "`3'"
	tempvar bb
	qui {
		by `ivar': gen float `bb' = `tvar'-`tvar'[_n-1]
		by `ivar': replace `bb' = `bb'[2] if _n==1
		qui summ `bb'
		if _result(5) == 0 {
			noi di in red /*
			*/ "`rtvar' has duplicate values within panel"
			exit 198
		}
	}
end


exit

note:  observations not equally spaced
       modal spacing is delta timevar = xxx
       14 groups omitted from estimation

note:  some groups have fewer than xx observations
       not possible to estimate correlations for those groups
       15 groups omitted from estimation

Took this out for logit and probit links:
	noi di in red "estimates diverging for logistic model"
	exit 198

