*! version 1.9.3  15apr1998

program define xtgls
	version 5.0
        if (substr("`1'",1,1)=="," | "`*'"=="") {
                if "$S_E_cmd"~="xtgls" {
                        error 301
                }
		parse "`*'"
                if "`level'" != "" {
                        if `level' < 10 | `level' > 99 {
                                local level = 95
                        }
                }
		DispRes `level'
		exit
	}
	mac drop X_*
	capture noi Estimate `*'
	mac drop X_*
	exit _rc
end
	


program define Estimate
        version 5.0

	local varlist   "req"
	local if        "opt"
	local in        "opt"
	local weight	"aweight"
		local options "Corr(string) FORCE I(string) ITERate(int 100) Level(int $S_level) noLOg IGLS NMK OLS Panels(string) PCSE T(string) TOL(real 1e-7)"
	parse "`*'"

	if `iterate' < 1 {
		noi di in red "iterate() must be positive"
		exit 198
	}

	if "`log'" != "" {
		local qqq "quietly"
	}
	else    local qqq "noisily"

	if "`weight'" != "" {
		tempvar www
		gen double `www' `exp'
		global X_wt "[aweight=`www']"
		global X_wtexp "[aweight`exp']"
		global X_wtvar "`www'"
	}
	else    global X_wt
		
	if "`pcse'" != "" {
		local ols "ols"
	}

	global X_if "`if'"
	global X_in "`in'"

	if "`level'" != "" {
		if `level' < 10 | `level' > 99 {
			local level = 95
		}
	}
		
	MapCorr `corr'
	local corr $S_1
	MapPanel `panels'
	local var $S_1
	local panels

	if "`corr'" != "0" {
		tempvar cons
		gen byte `cons' = 1
		global X_cons "`cons'"
		local fixname 1
	}

	if `var' == 2 {
		global X_bal = 1
	}
	else    global X_bal = 0

	xt_iis `i'
	global X_ivar "$S_1"
	sort $X_ivar


	if `corr' > 0 | `var' == 2 {
		xt_tis `t'
		global X_tvar "$S_1"
		global X_ttmp
	}
	else {
		tempvar tvar
		quietly by $X_ivar : gen `tvar' = _n
		quietly compress `tvar'
		global X_tvar "`tvar'"
		global X_ttmp 1
	}

	preserve
	parse "`varlist'", parse(" ")
	global X_depv "`1'"
	mac shift
	global X_indv "`*'"

	
	_rmcoll $X_indv $X_wt $X_if $X_in
	global X_indv "$S_1"

	quietly {	
		tempvar touse
		mark `touse' $X_if $X_in 
		markout `touse' $X_depv $X_indv $X_ivar $X_tvar
		if "`www'" != "" {
			replace `touse' = 0 if `www'<= 0
		}

		keep if `touse'
		if "`corr'" != "0" {
			by $X_ivar : replace `touse'=0 if _N==1
			count if `touse'==0
			local drop = _result(1)
			if `drop'>0 {
				keep if `touse'
				noi di in blue "Note: " in ye `drop' /*
				*/ in blue " observations dropped" /*
				*/ " because only 1 obs in group"
			}
		}

		tempvar ii
		egen `ii' = group($X_ivar)
		compress `ii'
		global X_itemp "`ii'"
	
		if "$X_tvar" != "" {
			tempvar tt
			egen `tt' = group($X_tvar)
			compress `tt'
			global X_ttemp "`tt'"
		}

		if `corr' > 0 {
			checkt $X_tvar `touse'
			if $S_1==2 {
				noi di in red /*
				*/ "$X_tvar has duplicate values within panel"
				exit 498
			}
			if $S_1==1 & "`force'" == "" {
				noi di in red /*
*/ "$X_tvar is not regularly spaced -- use the force option to override"
				exit 498
			}
		}

		drop `touse'

		ChkBal   
		if $S_1 == 1 {
			noi di in red "panels must be balanced"
			exit 498
		}
		if $S_1 == 2 {
			noi di in red /*
				*/ "$X_tvar has duplicate values within panel"
			exit 498
		}
		if $S_1 == 3 {
			noi di in red /*
				*/ "$X_tvar has different values across panels"
			exit 498
		}

		GetNKT
		if $X_ng == 1 & `var'==2 {
			local var = 1
		}
		if $X_nt < 2 & `corr' > 0 {
			local corr 0
		}

		tempname sigmat
		mat `sigmat' = J(1,$X_ng,0)
		global X_sig "`sigmat'"

		tempname E Ei
		tempname xEx xEix xEiy xxi xty beta vce pcvce bold
		tempname ovce obeta

		global X_Emat "`E'"
		global X_beta "`beta'"

		local diff = `tol'+1
		local iter = 0

		if "$X_cons" != "" {
			local copt "nocons"
		}

		if `var' < 2 {
			tempvar ee
			gen double `ee' = .
			global X_ee "`ee'"
		}
		else {
			gen double _ee = .
			global X_ee "_ee"
		}
			

		while `iter' < `iterate' & `diff' > `tol' {

			if "`igls'" == "" {
				local diff = 0
			}

			mc`corr' `iter'
			if `var' == 2 & "`ols'" == "" {
				mv1
			}
			else  mv`var'

			if `iter' == 0 {
				mat $X_sig = $X_Emat
			}

			mat `Ei' = syminv(`E')

			sort $X_ttemp $X_itemp
			mat glsaccum `xEx' = $X_indv /*
				*/ $X_cons $X_wt, `copt' /*
				*/ glsmat(`E') row($X_itemp) /*
				*/ group($X_ttemp)

			mat glsaccum `xEix' = $X_depv /*
				*/ $X_indv /*
				*/ $X_cons $X_wt, `copt' /*
				*/ glsmat(`Ei') /*
				*/ row($X_itemp) /*
				*/ group($X_ttemp)

			local s = rowsof(`xEix')
			mat `xEiy' = `xEix'[2..`s',1]
			mat `xEix' = `xEix'[2..`s',2..`s']

			global X_ecoe = `s' - 1

			mat accum `xxi' = $X_indv $X_cons /*
				*/  $X_wt, `copt'
			mat `xxi' = syminv(`xxi')

			mat vecaccum `xty' = $X_depv $X_indv /*
				*/ $X_cons $X_wt, `copt'

			local nobs = _result(1)
			local p = rowsof(`xxi')

			mat `vce' = syminv(`xEix')
			mat `beta' = `vce' * `xEiy'
			mat `beta' = `beta' '

			if `var' == 2 & "`ols'" == "" {
				mc`corr' 1
				mv2
				mat `Ei' = syminv(`E')

				sort $X_ttemp $X_itemp
				mat glsaccum `xEx' = $X_indv /*
					*/ $X_cons $X_wt, /*
					*/ `copt' /*
					*/ glsmat(`E') /*
					*/ row($X_itemp) /*
					*/ group($X_ttemp)

			mat glsaccum `xEix' = $X_depv /*
				*/ $X_indv /*
				*/ $X_cons $X_wt, `copt' /*
				*/ glsmat(`Ei') /*
				*/ row($X_itemp) /*
				*/ group($X_ttemp)

				local s = rowsof(`xEix')
				mat `xEiy' = `xEix'[2..`s',1]
				mat `xEix' = /*
				*/ `xEix'[2..`s',2..`s']

				global X_ecoe = `s' - 1

				mat accum `xxi' = $X_indv /*
					*/ $X_cons $X_wt, `copt'
				mat `xxi' = syminv(`xxi')

				mat vecaccum `xty' = /*
					*/ $X_depv $X_indv /*
					*/ $X_cons $X_wt, `copt'

				local nobs = _result(1)
				local p = rowsof(`xxi')

				mat `vce' = syminv(`xEix')
				mat `beta' = `vce' * `xEiy'
				mat `beta' = `beta' '
			}

			if `iter' == 0 {
				mat `bold' = `beta'
			}
			else {
				local diff = mreldif(`beta',`bold')
				mat `bold' = `beta'
				`qqq' di in gr "Iteration " `iter' /*
				*/ ": tolerance = " in ye `diff' 
			}
			local iter = `iter' + 1
		}

		mc`corr' `iter'

		if `var' == 2 & "`ols'" == "" {
			mv1
			mc`corr' `iter'
			mv2
		}
		else  mv`var'

		mat `pcvce' = `vce'
		mat `ovce' = `xxi'*`xEx'
		mat `ovce' = `ovce'*`xxi'
		mat `obeta' = `xty'*`xxi'

		if "`ols'" != "" {
			mat `beta' = `obeta'
			mat `vce' = `ovce'
			global X_tle "ordinary least squares"
		}
		else {
			global X_tle "generalized least squares"
		}

		tempvar ehat
		mat score double `ehat' = `beta' 
		replace `ehat' = $X_depv - `ehat'
		calcll `var' `ehat'

		if "`nmk'" != "" {
			tempname s1
			local k = colsof(`beta')
			scalar `s1' = `nobs'/(`nobs'-`k')
			mat `vce' = `vce'*`s1'
		}

		local rho  "$rho"
		local bp = colsof(`beta')

		if "`fixname'" != "" {
			local bnam : colnames(`beta')
			local nnam : word count `bnam'
			parse "`bnam'", parse(" ")
			local `nnam' "_cons"
			local bnam "`*'"
			mat colnames `beta' = `bnam'
			mat colnames `vce' = `bnam'
			mat rownames `vce' = `bnam'
			mat colnames `pcvce' = `bnam'
			mat rownames `pcvce' = `bnam'
		}

		global X_miss = $X_nobs - `nobs'
		global X_nobs = `nobs'


		if `var' == 0 {
			global X_ecov = 1
		}
		else if `var' == 1 {
			global X_ecov = $X_ng
		}
		else    global X_ecov = $X_ng * ($X_ng + 1) / 2

		global X_ecor : word count $X_rho
		local df = $X_nobs - $X_ecoe - $X_ecov - $X_ecor

		mat post `beta' `vce', /*
			*/ obs(`nobs') depname($S_E_depv) `dfopt'  

		if "`ols'"!="" {
			global S_E_vce "Panel Corrected"
		}
		else {
			global S_E_vce
		}

		SetGlob
		restore
	}

	if "`iter'" != "" {
		if `iter' > 1 {
			noi di 
		}
	}
	else noi di 
	noi DispRes `level'
end


program define DispRes

	local level = `1'

	di in gr "Cross-sectional time-series FGLS regression" _n
	di in gr "Coefficients:  " in ye "$S_E_tle"
	di in gr "Panels:	 " in ye "$S_E_vt"
	local nc : word count $S_E_rho
	if `nc' == 1 {
		local myrho : di %9.4f $S_E_rho
		di in gr "Correlation:   " in ye "$S_E_ct" in gr /*
		*/ "  (" in ye trim("`myrho'") in gr ")" 
	}
	else {
		di in gr "Correlation:   " in ye "$S_E_ct"
	}
	di

	di in gr "No. est. covariances" _col(27) "= "  in ye %9.0g $S_E_ncv /*
	*/ in gr _col(47) "No. of obs" _col(68) "= " in ye %9.0g $S_E_nobs

	di in gr "No. est. autocorrelations" _col(27) "= "  in ye /*
	*/ %9.0g $S_E_ncr /*
	*/ in gr _col(47) "No. of groups" _col(68) "= " in ye %9.0g $S_E_ng
	
	di in gr "No. est. coefficients" _col(27) "= "  in ye %9.0g $S_E_ncf /*
	*/ in gr _col(47) "No. of time periods" _col(68) "= " in ye %9.0g /*
	*/$S_E_nt

	if $S_E_chi2 > 999999 { 
		local cfmt "%9.0g" 
	}
	else	local cfmt "%9.2f"

	di /*
	*/ in gr _col(47) "chi2(" $S_E_mdf ")" _col(68) "= " /*
	*/ in ye `cfmt' $S_E_chi2 


	di in gr "Log Likelihood" _col(27) "= "  in ye %9.0g $S_E_ll /*
	*/ in gr _col(47) "Pr > chi2" _col(68) "= " in ye /* 
	*/ %9.4f chiprob($S_E_mdf, $S_E_chi2) 

	di
	
	mat mlout, level(`level')

	if $S_E_pdf <= 0 {
		noi di
		noi di in blue "Note: " _c
		noi di in blue "You estimated at least as many quantities " _c
		noi di in blue "as you have observations."
	}
end


program define SetGlob
	global S_E_tle "$X_tle"
	global X_tle
	global S_E_nobs $X_nobs
	global S_E_ng $X_ng
	global S_E_nt $X_nt
	global S_E_depv "$X_depv"
	global S_E_indv  "$X_indv"
	global S_E_vl  "$X_depv $X_indv"
	global S_E_ivar "$X_ivar"
	if "$X_ttmp" == "" {
		global S_E_tvar "$X_tvar"
	}
	else    global S_E_tvar
	global S_E_if "$X_if"
	global S_E_in "$X_in"
	global S_E_rho "$X_rho"
	global S_E_ncf  $X_ecoe
	global S_E_ncv  $X_ecov
	global S_E_ncr : word count $S_E_rho
	global S_E_pdf  $S_E_nobs - $S_E_ncv - /*
		*/ $S_E_ncr - $S_E_ncf
	global S_E_mis  $X_miss
	global S_E_vt "$X_var"
	global S_E_ct "$X_corr"
	global S_E_ll  $X_ll
	mat S_E_om = $X_Emat
	global S_E_wt "$X_wtexp"
	if "$X_indv" != "" {
		qui test $X_indv, min
		global S_E_mdf = _result(3) 
		global S_E_chi2 = _result(6)
	}
	else {
		global S_E_mdf  0
		global S_E_chi2  .
	}
	global S_E_cmd "xtgls"
end


program define mv0
	quietly {
		mat $X_Emat = J($X_ng,$X_ng,0)
		replace $X_ee = $X_ee * $X_ee
		summ $X_ee $X_wt
		local res = _result(3)
		global S_1 = $X_ng * log(_result(3))
		local i 1
		while `i' <= $X_ng {
			mat $X_Emat[`i',`i'] = `res'
			local i = `i'+1
		}
		global X_var "homoscedastic"
	}
end


program define mv1
	quietly {
		mat $X_Emat = J($X_ng,$X_ng,0)
		replace $X_ee = $X_ee * $X_ee
		global S_1 = 0.0
		local i 1
		while `i' <= $X_ng {
			summ $X_ee if $X_itemp == `i' $X_wt
			mat $X_Emat[`i',`i'] = _result(3)
			global S_1 = $S_1 + log(_result(3))
			local i = `i'+1
		}
		global X_var "heteroscedastic"
	}
end


program define mv2
	quietly {
		tempfile svme 
		save `svme'
		sort $X_itemp $X_ttemp
		replace $X_ee = $X_ee / sqrt($X_nt)
		keep $X_ee $X_itemp $X_ttemp

		local i $X_ng
		while `i' >= 2 {
			local b0 = (`i'-1)*$X_nt
			gen double ${X_ee}`i' = $X_ee[`b0'+_n] in 1/$X_nt
			local b0 = `b0' + 1
			drop in `b0'/l
			local i = `i' - 1
		}
		local elist "$X_ee"
		local i 2
		while `i' <= $X_ng {
			local elist "`elist' ${X_ee}`i'"
			local i = `i' + 1
		}
			

/*
		local i 1
		while `i' <= $X_ng {
			local b0 = (`i'-1)*$X_nt
			gen double ${X_ee}`i' = $X_ee[`b0'+_n] in 1/$X_nt
			local elist "`elist' ${X_ee}`i'"
			local i = `i' + 1
		}
		keep in 1/$X_nt
*/
		

		mat accum $X_Emat = `elist', nocons 
		global S_1 = 0.0
		local p 1
		while `p' <= $X_ng {
			global S_1 = $S_1 + log($X_Emat[`p',`p']/2)
			local p = `p'+1
		}
		use `svme', clear
		global X_var /*
		*/ "heteroscedastic with cross-sectional correlation"
	}
end


program define mc0
	local flag `1'

	if `flag' == 0 {
		capture drop $X_ee
		reg $X_depv $X_indv $X_cons $X_wt, $X_cot
		predict double $X_ee, resid
		global X_corr "no autocorrelation"
	}
	else {
		capture drop $X_ee
		mat score double $X_ee = $X_beta
		replace $X_ee = $X_depv - $X_ee
	}
end


program define mc1
	local flag `1'

	if `flag' == 0 {
		tempvar mm v1 q

		gen byte `mm' = 0
		gen double `v1' = .
		sort $X_itemp
		by $X_itemp : replace `mm' = 1 if _n==1
		reg $X_depv $X_indv $X_cons $X_wt, hascons
		capture drop $X_ee
		predict double $X_ee, resid

		global X_rho = 0
		local nn = 0       /* New */
		local i 1
		while `i' <= $X_ng {
			replace `v1' = $X_ee*$X_ee[_n-1] if $X_itemp == `i'
			summ `v1' if $X_itemp == `i' & `mm' == 0 $X_wt
			local rho = _result(3)
			replace `v1' = $X_ee*$X_ee       if $X_itemp == `i'
			summ `v1' if $X_itemp == `i' & `mm' == 0 $X_wt
			local rho = `rho'/_result(3)
			local nn = `nn'+_result(1) /* New */
			global X_rho = $X_rho + `rho'*_result(1) /* New */
			local i = `i'+1
		}
		drop `v1'
		global X_rho = $X_rho / `nn'   /* $X_ng  New */

		gen double `q' = .
		local rho = $X_rho
		local i 1
		while `i' <= $X_ng {
			parse "$X_depv $X_indv $X_cons", parse(" ")
			local j 1
			while "``j''" != "" {
				replace `q' = ``j'' - `rho' * ``j''[_n-1] /*
					*/ if `mm'==0 & $X_itemp==`i'
				replace `q' = sqrt(1-`rho'*`rho') * ``j'' /*
					*/ if `mm'==1 & $X_itemp == `i'
				replace ``j'' = `q' if $X_itemp==`i'
				local j = `j'+1
			}
			local i = `i'+1
		}
		drop `q' `mm' 
		capture drop $X_ee
		reg $X_depv $X_indv $X_cons $X_wt, nocons
		predict double $X_ee, resid
		global X_corr "common AR(1) coefficient for all panels"
	}
	else {
		capture drop $X_ee
		mat score double $X_ee = $X_beta 
		replace $X_ee = $X_depv - $X_ee
	}
end


program define mc2
	local flag `1'

	if `flag' == 0 {
		tempvar mm v1 q

		gen byte `mm' = 0
		gen double `v1' = .
		sort $X_itemp
		by $X_itemp : replace `mm' = 1 if _n==1
		reg $X_depv $X_indv $X_cons $X_wt, hascons
		capture drop $X_ee
		predict double $X_ee, resid

		gen double `q' = .
		global X_rho ""
		local i 1
		while `i' <= $X_ng {
			replace `v1' = $X_ee*$X_ee[_n-1] if $X_itemp == `i'
			summ `v1' if $X_itemp == `i' & `mm' == 0 $X_wt
			local rho = _result(3)
			replace `v1' = $X_ee*$X_ee       if $X_itemp == `i'
			summ `v1' if $X_itemp == `i' & `mm' == 0 $X_wt
			local rho = `rho'/_result(3)
			global X_rho "$X_rho `rho'"

			parse "$X_depv $X_indv $X_cons", parse(" ")
			local k 1
			while "``k''" != "" {
				replace `q' = ``k'' - `rho' * /*
					*/ ``k''[_n-1] /*
					*/ if `mm'==0 & $X_itemp==`i'
				replace `q' = sqrt(1-`rho'*`rho') * /*
					*/ ``k'' /*
					*/ if `mm'==1 & $X_itemp == `i'
				replace ``k'' = `q' if $X_itemp==`i'
				local k = `k'+1
			}

			local i = `i'+1
		}
		capture drop $X_ee
		reg $X_depv $X_indv $X_cons $X_wt, nocons
		predict double $X_ee, resid
		global X_corr "panel-specific AR(1)"
	}
	else {
		capture drop $X_ee
		mat score double $X_ee = $X_beta 
		replace $X_ee = $X_depv - $X_ee
	}
end


program define ChkBal
	global S_1 = 0
	if $X_bal == 0 {
		exit
	}

	/* Check for balanced panels */

	global S_1 0
	tempvar use
	mark `use' 
	markout `use' $X_depv $X_indv $X_ivar $X_tvar
	*replace `use' = `use' * $X_ttemp
	tempvar test
	egen `test' = sum(`use'), by($X_itemp)
	summ `test'
	if _result(5) != _result(6) {
		global S_1 1		/* Not balanced */
		exit
	}

	/* Check for duplicate values in panel & equal values across panels */
	tempvar t1 t2
	tab $X_tvar if `use', cgen(`t1')
	sort $X_ivar $X_tvar
	capture by $X_ivar : assert `t1' != `t1'[_n-1] if _n>1
	if _rc {
		global S_1 2		/* Duplicate values in panel */
		exit
	}

	egen `t2' = sum(`t1') if `use', by($X_ivar)
	summ `t2'
	if _result(5) != _result(6) {
		global S_1 3		/* Unequal values across panels */
		exit
	}
	sort $X_ivar $X_tvar
end


program define GetNKT
	summ $X_itemp
	global X_ng = _result(6)
	tempname XX
	capture mat `XX' = I($X_ng)
	if _rc {
		noi di in red "matsize too small - should be at least " $X_ng
		exit 908
	}
	summ $X_ttemp
	global X_nt = _result(6)
	global X_ntmin = _result(5)
	global X_ntavg = _result(3)
	global X_nobs = _N
end



program define MapCorr /* corr */
	local l = length("`1'")

	if "`1'"==substr("independent",1,`l') | `l'==0 { 
		global S_1 0
		exit
	}
	if "`1'"==substr("ar1",1,`l') {
		global S_1 1
		exit
	}
	if "`1'"==substr("psar1",1,`l') {
		global S_1 2
		exit
	}
	if "`1'"=="0" | "`1'"=="1" | "`1'"=="2" {
		global S_1 `1'
		exit
	}
	di in red "corr(`1') invalid"
	exit 198
end

program define MapPanel /* panel */
	local l = length("`1'")
	if "`1'"==substr("iid",1,`l') | `l'==0 {
		global S_1 0
		exit
	}
	if "`1'"==substr("heteroskedastic",1,`l') | /*
	*/ "`1'"==substr("heteroscedastic",1,`l') {
		global S_1 1
		exit
	}
	if "`1'"==substr("correlated",1,`l') {
		global S_1 2
		exit
	}
	if "`1'"=="0" | "`1'"=="1" | "`1'"=="2" {
		global S_1 `1'
		exit
	}
	di in red "panel(`1') invalid"
	exit 198
end

program define checkt
	local tvar  "`1'"
	local touse "`2'"

	global S_1 = 0
	sort $X_ivar `tvar'
	tempvar tt
	by $X_ivar : gen `tt' = `tvar'-`tvar'[_n-1] if `touse'!=.
	by $X_ivar : replace `tt' = `tt'[_N] if _n==1
	summ `tt'
	if _result(5) == 0 {
		global S_1 = 2
		exit
	}
	by $X_ivar : replace `tt' = `tt' != `tt'[_N]
	summ `tt'
	if _result(5) != _result(6) {
		global S_1 = 1
	}
end

program define calcll
	local var = `1'
	local ehat "`2'"

	tempname Sigi tr xEix  ss 

	mat `Sigi'  = $X_Emat
	scalar `ss' = rowsof(`Sigi')/trace(`Sigi')
	mat `Sigi' = `Sigi'*`ss'
	scalar `tr' = ln(det(`Sigi')^(1/$X_ng)) - ln(`ss')
	*scalar `tr' = ln(det(`Sigi')^(1/$X_ng))
	mat `Sigi' = $X_Emat
	mat `Sigi' = syminv(`Sigi')
	scalar `ss' = 1/sqrt(_N)
	mat `Sigi' = `Sigi' * `ss'
	sort $X_ttemp $X_itemp
	mat glsaccum `xEix' =  `ehat' /*
		*/ $X_wt, nocons /*
		*/ glsmat(`Sigi') /*
		*/ row($X_itemp) /*
		*/ group($X_ttemp)
	scalar `ss' = `xEix'[1,1]
	global X_ll = -_N/2*ln(2*_pi) - _N*`tr'/2 - `ss'/2
end
	
exit
